
alias(Heap = adt::Heap):
alias(Heap_node = (adt::Heap)::Heap_node):

proc()
    local path;
begin

    Heap := newDomain("adt::Heap"):
    Heap_node := newDomain("(adt::Heap)::Heap_node"):
	
    path := pathname("ADT", "HEAP"):
    
    Heap::new 		:= 	loadproc(Heap::new,		path,"new"):
    Heap::ins 		:= 	loadproc(Heap::ins,		path,"new"):
    Heap::del_min 	:= 	loadproc(Heap::del_min,		path,"new"):
    Heap::del_ins	:= 	loadproc(Heap::del_ins,		path,"new"):
    Heap::del_ins_bound	:= 	loadproc(Heap::del_ins_bound,	path,"new"):


    Heap::empty 	:= 	loadproc(Heap::empty,		path,"new"):
    Heap::mini		:= 	loadproc(Heap::mini,		path,"new"):
    Heap::print		:= 	loadproc(Heap::print,		path,"new"):
    Heap::up 		:= 	loadproc(Heap::up,		path,"new"):
    Heap::up_bound 	:= 	loadproc(Heap::up_bound,	path,"new"):
    Heap::down 		:= 	loadproc(Heap::down,		path,"new"):
    Heap::down_botup	:= 	loadproc(Heap::down_botup,	path,"new"):
 

    path := pathname("ADT", "HEAP", "HEAPNODE"):
	
    Heap_node::new 	:= 	loadproc(Heap_node::new,	path,"new"):
    Heap_node::_less 	:= 	loadproc(Heap_node::_less,	path,"new"):
    Heap_node::value 	:= 	loadproc(Heap_node::value,	path,"new"):
    Heap_node::content 	:= 	loadproc(Heap_node::content,	path,"new"):
    Heap_node::print 	:= 	loadproc(Heap_node::print,	path,"new"):
    Heap_node::_leequal	:= 	loadproc(Heap_node::_leequal,	path,"new"):
    Heap_node::dispose 	:= 	loadproc(Heap_node::dispose,	path,"new"):
    
end_proc():


unalias(Heap_node):
unalias(Heap):
