alias(DAT(x)=detools::data[x],
      CDAT(x)=contains(detools::data,x)):
      
detools::transform :=
    proc()
    local newArgs:DOM_LIST, newEqs:DOM_LIST;
    begin
	// analysis of input
	detools::getdata(testargs(),args());
	// testargs
	if ((DAT("DFin"))::hasProp(Dom::LinearDifferentialFunction) 
	     or
	    (DAT("DFin"))::hasProp(Dom::DifferentialExpression))  
	    then
	    newArgs := [DAT("NewVars"),DAT("ChangeOfVars")];
	    if CDAT("OldFromNew") then
		newArgs := newArgs.[OldFromNew=DAT("OldFromNew")];
	    end_if;
	    if CDAT("OutputDomain") then
		newArgs := newArgs.[OutputDomain=DAT("OutputDomain")];
	    end_if;
	    if has(DAT("Parms"),"Dep") then
		newEqs :=
         	   map(DAT("Eqs"),(DAT("DFin"))::changeDepVars,op(newArgs));
	    elif has(DAT("Parms"),"Indep") then 
		newEqs :=
		   map(DAT("Eqs"),(DAT("DFin"))::changeIndVars,op(newArgs));
	    end_if;
	    if DAT("System") then
		return(newEqs);
	    else
		return(op(newEqs));
	    end_if;
	else
            error("Change of variables for this domain not yet implemented");
	end_if;
    end_proc; /* detools::transform */
    
