// $Date: 1999/10/15 06:30:08 $ $Author: frankp $ $Revision: 1.4 $

/*
	Ax::canonicalRep 

	This axiom states that the elements of a domain are
	represented canonically, i.e. that each element of the 
	domain has only one unique expression which represents it.

	This axiom implies that for an abelian monoid the axiom 
	Ax::normalRep also holds. This is not enforced by the category 
	but must be stated by the implementor of a domain.
*/

axiom Ax::canonicalRep end:

