// $Date: 2000/05/21 14:53:12 $ $Author: bij $ $Revision: 1.5 $ 
/*++
Cat::Algebra -- the category of associative algebras

Cat::Algebra(R)

R - a Cat::CommutativeRing

An Cat::Algebra is a module over R which also is a ring.

Methods:-
++*/

category Cat::Algebra(R)
  category Cat::Ring, Cat::Module(R);
begin    
  if args(0) <> 1 then error("wrong no of args") end_if;
  if not R::hasProp(Cat::CommutativeRing) then
      error("no commutative ring")
  end_if;
end_category:

