// $Date: 2000/05/21 14:53:14 $ $Author: bij $ $Revision: 1.4 $ 
/*++
Cat::DifferentialRing -- the category of ordinary differential rings

Cat::DifferentialRing

A differential ring is a commutative ring with a single derivation
operator D. The derivation is written as follows:

	D(f)		derivation of f

or as

	diff(f, x)	differentiation of f with respect to x

where x is the only one indeterminate of the ring.
++*/

category Cat::DifferentialRing

    category Cat::PartialDifferentialRing ;
    
begin   
  if args(0) <> 0 then error("wrong no of args") end_if;
end_category:
