// $Date: 2000/05/21 14:53:16 $ $Author: bij $ $Revision: 1.5 $ 
/*++
Cat::Group -- the category of groups

A Cat::Group is a Cat::Monoid where the operation '*' is invertible.

Methods:
_divide(x,y) - returns x * y^(-1)
++*/

category Cat::Group
    category Cat::Monoid ;

    _divide := proc(x,y) begin dom::_mult(x, dom::_invert(y)) end_proc;

begin

end_category:


