/*++
Cat::OrderedMonoid -- the category of ordered monoids

It is always assumed that the ordering is compatible with the
monoid operation, i.e. x < y => x*z < y*z and this::one is the
smallest element of the monoid.

Author: Werner M. Seiler, Uni Karlsruhe
Created: July 1st, 1997
++*/

category Cat::OrderedMonoid
	category Cat::Monoid, Cat::OrderedSet;
	
begin

end_category:
