// $Date: 2000/05/21 14:53:20 $ $Author: bij $ $Revision: 1.6 $ 
/*++
Cat::SemiGroup -- the category of semi-groups

A Cat::SemiGroup is a set with an associative operation '*'.

Methods:
_mult(x1,x2,...) - returns the product of x1*x2*...
_power(x,i)      - returns x*x*...*x (i times) for a positive integer i
++*/

category Cat::SemiGroup
    category Cat::BaseCategory;

    _mult;

    _power := domains::repeatedSquaring(dom, "_mult");
    
begin

end_category:

