// $Date: 2000/05/21 14:53:34 $ $Author: bij $ $Revision: 1.6 $ 

/*++
axioms -- get set of axioms of domain

axioms(Dom)

Dom - domain

Use domain constructor and actual parameters of domain to create a
set of the direct axioms of the domain on the fly.
++*/

DomainConstructor::axioms:= proc(DOM: DOM_DOMAIN): DOM_SET
    option noDebug;
    local A, i;
begin
    // create set of actual axioms 
    A:= extop(DOM::constructor,3);
    { _eval_entry(A[i], DOM, DOM::closure) $ i=1..nops(A) } minus {NIL}
end_proc:

// end of file 
