// $Date: 2000/05/21 14:53:35 $ $Author: bij $ $Revision: 1.6 $ 

/*++
categories -- get list of (direct) categories of domain

categories(Dom)

Dom - domain

Use domain constructor and actual parameters of domain to create a
list of the direct categories of the domain on the fly.
++*/

DomainConstructor::categories:= proc(DOM: DOM_DOMAIN): DOM_LIST
    option noDebug;
    local C, i;
begin
    // create list of actual categories 
    C:= extop(DOM::constructor,2);
    select([ _eval_entry(C[i], DOM, DOM::closure) $ i=1..nops(C) ],
	   _unequal, NIL);
end_proc:

// end of file 
