// $Date: 2000/05/21 14:53:36 $ $Author: bij $ $Revision: 1.5 $ 

/*++
_index -- get definition of entry

_index(DC, e)

DC - domain constructor
e  - entry name (string)

_index returns the unevaluated definition of the entry e of DC or 
FAIL if e is not directly defined for DC.
++*/

DomainConstructor::_index:= proc(DC: DomainConstructor, e: DOM_STRING)
    option noDebug;
begin
    indexval(extop(DC,4), e)
end_proc:

// end of file 
