// $Date: 2000/05/21 14:54:26 $ $Author: bij $ $Revision: 1.6 $ 

// kg, 20/02/95 

/*--
groebner::primpart -- make rational non-zero polynomial primitive

groebner::primpart(p)

p - non-zero rational polynomial

additional argument o does no harm if given
--*/

groebner::primpart:=
	((p)->(multcoeffs(p, 1/icontent(p)))):

/*--
groebner::normalize -- normalize non-zero polynomial over field

groebner::normalize(p, o)

p - non-zero polynomial over field
o - term ordering 
--*/

groebner::normalize:=
	((p,o)->(multcoeffs(p, 1/lcoeff(p, o)))):

// end of file 
