// $Date: 2000/05/21 14:54:29 $ $Author: bij $ $Revision: 1.6 $ 

// kg, 21/03/95 

/*--
test_domain -- tests if coefficient domain has methods for groebner package

groebner::test_domain(d)

d - coefficient domain
--*/

groebner::test_domain:= proc(d)
begin
    if d::hasProp(Cat::Field) = TRUE then
        TRUE
    else
	map(["_plus", "_negate", "_mult", "_invert", "_power", "_divide", "zero", "one"],
	    proc() begin 
                if slot(args(2), args(1)) = FAIL then
		    error("domain entry \"".args(1)."\" missing")
	        end_if 
            end_proc, d)
    end_if
end_proc:

// end of file 
