// $Date: 2000/05/21 14:54:38 $ $Author: bij $ $Revision: 1.4 $ 
/*--
intlib::algred(f,n) - reduces f modulo the polynomials in k_alg and returns 
numerator and denominator.
--*/
intlib::algred:=proc(f,n)
  local i;
// global k_sub,k_alg; 
begin
  if n<2 or (map({op(k_alg)},domtype)minus{DOM_INT}={})
    then return(normal(f));
  end_if;
  for i from n downto 2 do
    if domtype(k_alg[i])=DOM_POLY then
      f:= expr(intlib::sim(divide(poly(numer(f),[k_sub[i]])*
	         intlib::pdioe(divide(poly(denom(f),[k_sub[i]]),k_alg[i],Rem),
                 k_alg[i],poly(1,[k_sub[i]]))[1],k_alg[i],Rem)));
      else next;
    end_if;
  end_for;
  return(normal(f));
end_proc:
