// $Date: 2000/05/21 14:54:46 $ $Author: bij $ $Revision: 1.5 $ 
/*--
intlib::subst(f,opt) - substitutes the functions sin,cos,.. in f
It uses the remember table sub
--*/
intlib::subst:=proc(f, opt)
  local  L,i;
  save notnagel_f;
/* global opt; now removed !!
  global notnagel_f introduced instead of global used f */
begin
  if type(f)=DOM_PROC then return(FAIL) end_if;
  notnagel_f:=f;
  L:=null();
  for i in f do
    if op(i,0) = FAIL 
      then L:=L,i;
      else L:=L,intlib::subst(i,opt);
    end_if; 
  end_for;
  intlib::sub(op(f,0),opt)(L);
end_proc:
