// $Date: 2000/05/21 14:55:09 $ $Author: bij $ $Revision: 1.9 $ 

/*++
	adt - Library for abstract data types 

++*/

adt:=newDomain("adt"):
adt::info:="Library 'adt':  a collection of abstract data types":
adt::interface:={hold(Stack), hold(Queue), hold(Tree)}:

alias(path = pathname("ADT")):

adt::Heap:= loadproc(adt::Heap, path, "heap"):
adt::Stack:= loadproc(adt::Stack, path, "stack"):
adt::Queue:= loadproc(adt::Queue, path, "queue"):
adt::Tree := loadproc(adt::Tree , path, "tree"):

adt::type:= ADT -> ADT::type:

stdlib::LoadlibState["adt"]:= TRUE:

null():

// end of file 
