// $Date: 2000/11/22 15:04:53 $ $Author: tonner $ $Revision: 1.11 $ 

// kg, 05/09/95 

/*--
generate.mu -- define/load functions generating foreign formats
--*/

generate:= newDomain("generate"):
generate::info:= "Library 'generate': generate foreign formats from expressions":
generate::interface:= { hold(TeX), hold(C), hold(fortran),
                        hold(optimize),
			hold(Macrofort)}:

alias(path = pathname("GENERATE")):

generate::TeX:= loadproc(generate::TeX, path, "TeX"):
generate::TeXdef:= loadproc(generate::TeXdef, path, "TeX"):
generate::C:= loadproc(generate::C, path, "C"):
generate::fortran:= loadproc(generate::fortran, path, "fortran"):
generate::gb:= loadproc(generate::gb, path, "gb"):
generate::lisp:= loadproc(generate::lisp, path, "lisp"):
generate::maple:= loadproc(generate::maple, path, "maple"):
generate::mathematica:= loadproc(generate::mathematica, path, "mma"):
generate::optimize:= loadproc(generate::optimize, path, "optimize" ):
generate::splitProduct:= loadproc(generate::splitProduct, path, "splprod"):
generate::sortSum:= loadproc(generate::sortSum, path, "sortsum"):
generate::isNeg:= loadproc(generate::isNeg, path, "sortsum"):

generate::Macrofort:= loadproc(generate::Macrofort, path, "Macrofort"):

stdlib::LoadlibState["generate"]:= TRUE:

null():

// end of file 
