// $Date: 2000/05/21 14:55:15 $ $Author: bij $ $Revision: 1.10 $ 

// kg, 13/12/94 

/*--
output.mu -- define/load auxiliary functions
--*/

output:= newDomain("output"):

output::info:= "Library 'output': utilities for the output of data":
output::interface:= {
    hold(ordinal), hold(tableForm), hold(tree)
}:
output::exported := {hold(Content), hold(MathContent)}:

alias(path = pathname("OUTPUT")):

output::ordinal  := loadproc(output::ordinal  , path, "ordinal"):
output::tableForm:= loadproc(output::tableForm, path, "tabForm"):
output::tree     := loadproc(output::tree     , path, "tree"   ):
output::isNeg     := loadproc(output::isNeg     , path, "isNeg"   ):
output::CatUtils        := loadproc(output::CatUtils, path, "CatUtils"):
output::CatContent      := loadproc(output::CatContent, path, "CatCont"):
output::CatPresentation := loadproc(output::CatPresentation, path, "CatPres"):


output::MMLpresentation := loadproc(output::MMLpresentation, path, "MMLpres"):

  // output::PlaceHolder:= loadproc(output::PlaceHolder, path, "xxxx"):
output::Indent          := loadproc(output::Indent, path, "Indent"):
output::Priority   := loadproc(output::Priority, path, "priority"):
output::operator   := loadproc(output::operator, path, "operator"):

stdlib::LoadlibState["output"]:= TRUE:

null():

// end of file 
