
stringlib:=newDomain("stringlib"):
stringlib::info:="Library 'stringlib': utilities for string manipulation":
stringlib::interface:={
      hold(contains), hold(subs), hold(subsop),
      hold(format), hold(formatf), hold(pos),
      hold(match), hold(remove)
}:

alias(path = pathname("STRINGLIB")):

stringlib::match    := loadproc(stringlib::match   , path, "match"   ):
stringlib::contains := loadproc(stringlib::contains, path, "contains"):
stringlib::subs     := loadproc(stringlib::subs    , path, "subs"    ):
stringlib::subsop   := loadproc(stringlib::subsop  , path, "subsop"  ):
stringlib::remove   := loadproc(stringlib::remove  , path, "remove"  ):
stringlib::format   := loadproc(stringlib::format  , path, "format"  ):
stringlib::formatf  := loadproc(stringlib::formatf , path, "formatf" ):
stringlib::pos      := loadproc(stringlib::pos     , path, "pos"     ):

stringlib::FirstIndex := 0:

stringlib::exported:= {}:

stdlib::LoadlibState["stringlib"]:= TRUE:

null():

/* strmatch and substring are used in read and pathname, therefore
   don't move them to this library */
