// 
// $Date: 2000/05/21 14:55:24 $  $Author: bij $   $Revision: 1.4 $ 
// 
// frankp, 29/07/94 

/*++
  nnz.mu

	linalg::nonZeros -- returns the no of non-zeros of a matrix
++*/

linalg::nonZeros:= proc(x)
begin
    if testargs() then
        if args(0) <> 1 then error("expecting 1 argument")
        elif x::dom::hasProp( Cat::Matrix ) <> TRUE then
            error("argument is not of 'Cat::Matrix'")
        end_if
    end_if;

    x::dom::nonZeros(x)
end_proc:

// end of file 
