// $Date: 2000/05/21 14:55:41 $ $Author: bij $ $Revision: 1.4 $ 
// sello, 12.6.97, siehe Diplomarbeit Meinolf Sellmann 1997  

/*++
elimobj.mu --  replace the old objective function by 0
++*/

alias(Heap=adt::Heap):
alias(Tableau = linopt::Tableau):

Tableau::elimobj	:=	proc(T)

/* Eingabe: Tableau T
  Ausgabe: neues Tableau T mit Zielfunktion 0
*/

				local tbl,n,		// Tableaukomponenten	
				      j;		// Laufvariable		

				begin
				  tbl := T[1]:
				  n := T[3]:
				  tbl := assignElements(tbl,[[2,j],0]$ j=2..n+2):
				  return(new(Tableau,tbl,T[2],n,T[4],T[5],T[6],T[7],T[8],T[9],T[10],T[11],T[12]))
				end_proc:

unalias(Tableau):
unalias(Heap):
