// $Date: 2000/05/21 14:55:41 $ $Author: bij $ $Revision: 1.2 $ 
// sello, 12.6.97, siehe Diplomarbeit Meinolf Sellmann 1997  

/*++
feasible.mu --  test whether Tableau T is feasible with respect to lequal-constraints (no integer feasibility tested!)
++*/

alias(Heap=adt::Heap):
alias(Tableau = linopt::Tableau):

Tableau::feasible	:=	proc(T)

/* Eingabe: Tableau T
  Ausgabe: TRUE oder FALSE
*/
				local piv;	// Pivotelement	

				begin
				  if T = {} then return(FALSE) end_if:
				  piv := Tableau::pivot1(T[1],T[2],T[3],T[9],T[2]+2):
				  return(piv[1] = 0)
				end_proc:

unalias(Tableau):
unalias(Heap):
