// $Date: 2000/05/21 14:55:41 $ $Author: bij $ $Revision: 1.4 $ 
// sello, 12.6.97, siehe Diplomarbeit Meinolf Sellmann 1997  

/*++
fulltab.mu -- compute ordinary tableau
++*/

alias(Heap=adt::Heap):
alias(Tableau = linopt::Tableau):


Tableau::full_tableau	:=	proc(T)
				local H, slackanz, i,j,k,l,fulltbl,tbl,m,n,scrollanz,interval,internalorder,pos,neg,unrestr,unrestrorder;
				begin
				  tbl := T[1]:
				  m := T[2]:
				  n := T[3]:
				  slackanz := T[7]:
				  scrollanz := T[8]:
				  interval := T[9]:
				  internalorder := T[11]:
				  unrestr := 0:
				  H := Heap():

				  for i from 3 to m+2 do
				    if interval[tbl[i,1],"greater"] = UNKNOWN
				      then H := Heap::ins(H,internalorder[tbl[i,1]],tbl[i,1])
				    end_if
				  end_for:

				  for j from 3 to n+2 do
				    if interval[tbl[1,j],"greater"] = UNKNOWN
				      then H := Heap::ins(H,internalorder[tbl[1,j]],tbl[1,j])
				    end_if
				  end_for:

				  unrestr := 0:
				  while not Heap::empty(H) do
				    unrestr := unrestr+1:
				    unrestrorder[Heap::mini(H)] := unrestr:
				    H := Heap::del_min(H)
				  end_while:

				  fulltbl := array(1..m+2,1..2+slackanz+n+unrestr):


				  fulltbl[2,2] := tbl[2,2]:
				  fulltbl[1,1] := "linopt":
				  fulltbl[2,1] := "obj":
				  fulltbl[1,2] := "restr":

				  for i from 3 to m+2 do
				    if interval[tbl[i,1],"greater"] = UNKNOWN 
				      then if tbl[i,2] >= 0 
					     then fulltbl[i,1] := pos[tbl[i,1]]:
						  fulltbl[i,2] := tbl[i,2]:
						  j := internalorder[tbl[i,1]]+2+slackanz:
						  fulltbl[1,j] := pos[tbl[i,1]]:
						  fulltbl[2,j] := 0:
						  for k from 3 to m+2 do
						    if k = i 
						      then fulltbl[k,j] := 1
						      else fulltbl[k,j] :=0
						    end_if
						  end_for:
						 j := unrestrorder[tbl[i,1]]+2+slackanz+n:
						 fulltbl[1,j] := neg[tbl[i,1]]:
						 fulltbl[2,j] := 0:
						 for k from 3 to m+2 do
						   if k = i 
						     then fulltbl[k,j] := -1
						     else fulltbl[k,j] :=0
						   end_if
						 end_for
					     else fulltbl[i,1] := neg[tbl[i,1]]:
						  fulltbl[i,2] := -tbl[i,2]:
						  j := internalorder[tbl[i,1]]+2+slackanz:
						  fulltbl[1,j] := pos[tbl[i,1]]:
						  fulltbl[2,j] := 0:
						  for k from 3 to m+2 do
						    if k = i 
						      then fulltbl[k,j] := -1
						      else fulltbl[k,j] :=0
						    end_if
						  end_for:
						 j := unrestrorder[tbl[i,1]]+2+slackanz+n:
						 fulltbl[1,j] := neg[tbl[i,1]]:
						 fulltbl[2,j] := 0:
						 for k from 3 to m+2 do
						   if k = i 
						     then fulltbl[k,j] := 1
						     else fulltbl[k,j] :=0
						   end_if
						 end_for
					   end_if
				      else fulltbl[i,1] := tbl[i,1]:
					   fulltbl[i,2] := tbl[i,2]:
					   j := internalorder[tbl[i,1]]+2+slackanz:
					   fulltbl[1,j] := tbl[i,1]:
					   fulltbl[2,j] := 0:
					   for k from 3 to m+2 do
					     if k = i 
					       then fulltbl[k,j] := 1
					       else fulltbl[k,j] :=0
					     end_if
					   end_for
				    end_if
				  end_for:

				  for j from 3 to n+2 do
				    if interval[tbl[1,j],"greater"] = UNKNOWN
				      then l := internalorder[tbl[1,j]]+2+slackanz:
					   fulltbl[1,l] := pos[tbl[1,j]]:
					   for i from 2 to m+2 do
					     fulltbl[i,l] := tbl[i,j]
					   end_for:
					   l := unrestrorder[tbl[1,j]]+2+slackanz+n:
					   fulltbl[1,l] := neg[tbl[1,j]]:
					   for i from 2 to m+2 do
					     fulltbl[i,l] := -tbl[i,j]
					   end_for
				      else l := internalorder[tbl[1,j]]+2+slackanz:
					   for i from 1 to m+2 do
					     fulltbl[i,l] := tbl[i,j]
					   end_for
				      end_if
				  end_for:
				  print(fulltbl) 
				end_proc:

unalias(Tableau):
unalias(Heap):
