// $Date: 2000/05/21 14:55:35 $ $Author: bij $ $Revision: 1.4 $ 
// sello, 12.6.97, siehe Diplomarbeit Meinolf Sellmann 1997 

/*++
easy.mu -- generate branchingcuts - very easy version
++*/

alias(Heap = adt::Heap):
alias(Tableau = linopt::Tableau):



   linopt::easy_branch	:=	proc(T)


/* liefert fuer ein gegebenes Tableau die zugehoerigen Tableaus zum linken und rechten Teilproblem.
  Branchingvariable ist die erste ganzzahlige, die dieser Restriktion bis jetzt noch nicht genuegt. 

  Eingabe: Ein Tableau
  Ausgabe: Liste mit den beiden Sohntableaus
*/


				local tbl,m,interval,integer,			// Tableaukomponenten 		
				      TU,TO,					/* Tableaus fuer das untere
										  und obere Teilproblem		*/
				      i;					// Laufvariable			

				begin
				  tbl := T[1]:

				  m := T[2]:
				  integer := T[12]:
				  interval := T[9]:

				  for i from 3 to m+2 do
				    if integer[tbl[i,1]] and tbl[i,2]<>floor(tbl[i,2])
				      then break
				    end_if
				  end_for:


				  if interval[tbl[i,1],"lower"] = UNKNOWN 
				    then TO := Tableau::newlowerbound(T,i,floor(tbl[i,2])+1):
					 if interval[tbl[i,1],"greater"] = UNKNOWN 
					   then TU := Tableau::newupperbound(T,i,floor(tbl[i,2]))
					   elif floor(tbl[i,2]) = 0 
					       then TU := Tableau::newequation(T,i,0)
					       else TU := Tableau::newupperbound(T,i,floor(tbl[i,2]))
					 end_if
				    else if interval[tbl[i,1],"lower"] >= floor(tbl[i,2])+1
				           then if interval[tbl[i,1],"greater"] 
					          then TO := Tableau::newlowerbound(T,i,floor(interval[tbl[i,1],"lower"]-tbl[i,2])+1)
					          else TO := Tableau::newlowerbound(T,i,floor(tbl[i,2])+1)
					        end_if
					   elif interval[tbl[i,1],"lower"] = floor(tbl[i,2])+1 
					       then TO := Tableau::newequation(T,i,floor(tbl[i,2])+1)
					       else TO := {}
					 end_if:
					 if interval[tbl[i,1],"greater"] 
					   then if floor(interval[tbl[i,1],"lower"]-tbl[i,2]) = 0
						  then TU := Tableau::newequation(T,i,0)
						  else TU := Tableau::newupperbound(T,i,floor(interval[tbl[i,1],"lower"]-tbl[i,2]))
						end_if
					   elif floor(tbl[i,2]) = 0 
					       then TU := Tableau::newequation(T,i,0)
					       else TU := Tableau::newupperbound(T,i,floor(tbl[i,2]))
					 end_if
				   end_if:

				   return([TO,TU])

				end_proc:


				
unalias(Tableau):
unalias(Heap):
