/*-
 printGraph - print all known information about the network
-*/
Network::printGraph := proc(g)
begin
   Network::graph_check(g);
   print(Unquoted, "Vertices: ".expr2text(Network::vertex(g)));
   print(Unquoted, "Edges: ".expr2text(Network::edge(g)));
   print(Unquoted, "Vertex weights: ".expr2text( Network::vWeight(g)));
   print(Unquoted, "Edge capacities: ".expr2text( Network::eCapacity(g)));
   print(Unquoted, "Edge weights: ".expr2text(Network::eWeight(g)));
   print(Unquoted, "Adjacency list (out): ".expr2text(Network::epost(g)));
   print(Unquoted, "Adjacency list (in): ".expr2text(Network::epre(g)));
end_proc:
