/* ode::mapsol(s,f) maps the function f on s, where s is a solution of an ODE,
  i.e. either FAIL or a set or a solve result or an union
*/

ode::mapsol :=
proc(_s,f)
  local a,l;
  save xx;
begin
  delete xx;
   case type(_s)
   of DOM_FAIL do return(FAIL)
   of DOM_SET do return(map(_s,args(2..args(0))))
   of "solve" do
      if f=_mult then
         a:=_mult(args(3..args(0)));
         l:=misc::subExpressions(op(_s,1),"int");
         l:=map(l,proc() begin (if op(args(1),2)=op(_s,2) then
		          args(1)=hold(int)(subs(op(args(1),1),op(_s,2)=xx/a)/a,xx)
                       else null() end_if) end_proc );
         _s:=subs(_s,l);
         _s:=subsop(_s,1=subs(op(_s,1),op(_s,2)=op(_s,2)/a));
         return(subs(_s,xx=op(_s,2)))
      else return(f(_s,args(3..args(0)))) end_if
   of "_union" do
      _s:=map(op(_s),ode::mapsol,args(2..args(0)));
      _s:=map(_s,proc() begin (if contains({DOM_SET,"solve"},type(args(1))) then args(1)
		    else {args(1)} end_if) end_proc );
      _union(_s)
   end_case
end_proc:
