DOM_ARRAY::Content :=
proc(Out, Array)
  local i,j,arg0;
begin
  arg0 := op(Array,0);
  if op(arg0, 1) = 2 then
    // Matrix
    Out::Cmatrix(
                 Out::Cmatrixrow(Out(Array[i,j]) $ j = op(arg0, 3))
                 $ i = op(arg0,2)
                 )
  else
    expr2text(Array); // error("not yet implemented"):
  end_if
end_proc:
DOM_ARRAY::Presentation := 
proc(Out:DOM_DOMAIN, data)
    local f, n, m, p, i, j;
  begin
    f := proc()
	 begin        // returns array entry or ?[indices] 
	   if contains(args(1), args(2..args(0))) then
	     Out::parenthesisOut(output::Priority::Exprseq,
				 [args(1)[args(2..args(0))]]);
	   else
	     Out::msub(Out::mi("?"), Out(args(2..args(0))));
	   end_if;
	 end_proc ;
    
    if op(data,[0,1]) = 1 then
        n:= op(data,[0,2,1]);
        m:= op(data,[0,2,2]);
    	if nops(op(data, 0)) = 2 then         // undevided vector 
	  Out::mfenced(
	    Out::mtable(
	      Out::mtr(f(data, i) $ i=n..m)
	    ));
	end_if;
    elif op(data,[0,1]) = 2 then
      if nops(op(data, 0)) = 3 then         // undevided matrix 
	  Out::mfenced(
	    Out::mtable(
	      Out::mtr(f(data, i, j) $ j=op(data,[0,3])) $ i=op(data,[0,2])
	    ));
      end_if;
    else
      p:= proc(x)
	    local i;
	  begin
	    if nops(x) = op(data,[0,1]) then
	      if  type(data[op(x)]) <> "_index" then
	      Out::mtr(Out::mfenced(Out(op(x))),
		       Out::mo("="),
		       f(data, op(x)));
	      else
		null()
	      end_if
	    else
	      p(x.[i]) $ i=op(data,[0,nops(x)+2])
	    end_if
	  end_proc;
      Out::mtable(hold(columnalign)="right center left" ,p([]));
    end_if
end_proc:
