DOM_COMPLEX::Content := proc(Out:DOM_DOMAIN, data:DOM_COMPLEX)
  local imagimary;
begin
  if op(data, 2) = 1 then
    imagimary := hold(`&ii;`);
  else
    imagimary := hold(_mult)(op(data, 2), hold(`&ii;`));
  end_if;
  if op(data, 1) = 0 then
    Out(imagimary)
  else
    Out(hold(_plus)(op(data, 1), imagimary))
  end_if;
end_proc:

DOM_COMPLEX::Presentation := 
proc(Out:DOM_DOMAIN, data:DOM_COMPLEX)
  local node;
begin
  if op(data, 1) = 0 then
    if op(data, 2) = 1 then
      node := Out::mi("&ImaginaryI;");
      node := new(Out::Representation, extop(node, 1),
		  output::Priority::Stmt,
		  extop(node,3..extnops(node)));
    else
      node := Out(hold(_mult)(op(data, 2), I));
      if not Out::isNeg(op(data, 2)) then
	node := new(Out::Representation, extop(node, 1),
		    output::Priority::Mult,
		    extop(node,3..extnops(node)));
      end_if;
    end_if;
    node;
  else
    Out(hold(_plus)(op(data, 1), op(data,2)*I))
  end_if
end_proc:
