    //------------------------------------------------------------
    // limit(f, x=y) -> lim f  and  limit(f, x=y, Left) -> lim  f 
    //                 x->y                               x->y-   
    //------------------------------------------------------------

limit::Presentation :=
proc(Out, data)
  local goesTo, appendix, ident;
begin
  if nops(data) < 2 or nops(data) > 3 then
    return(Out::stdFunc(data))
  end;
  if nops(data) = 2 then
    appendix := null();
  elif op(data, 3) = Left then
    appendix := Out::mo("-");
  else
    appendix := Out::mo("+");
  end_if;
  if type(op(data, 2)) = "_equal" then
    goesTo := op(data, [2,2]);
    ident  := op(data, [2,1]);
  else
    goesTo := 0;
    ident  := op(data, 2);
  end_if;
  
  Out::mrow(
            Out::munder(Out::mi("lim"),
                        Out::mrow(Out(ident),
                                  Out::mo("&RightArrow;"),
                                  Out(goesTo), appendix)),
            Out( op(data,1)));
end_proc:
