_seqgen::Presentation :=
proc(Out, data)
begin
  case nops(data)
    of 1 do       // unary sequence generator 
      Out::mrow(Out::mo("&dollar;"),
                Out(op(data, 1)));
      break;
    of 2 do
      Out::mrow(
                Out::parenthesisOut(output::Priority::Seqgen,
                                    [op(data, 1)]),
                Out::mo("&dollar;"),
                Out(op(data, 2)));
      break;
    of 3 do
      Out::mrow(
                Out::parenthesisOut(output::Priority::Seqgen,
                                    [op(data, 1)]),
                Out::mo("&dollar;"),
                Out(hold(_equal)(op(data, 2),
                                 op(data, 3))));
      break;
    otherwise
      Out::stdFunc(data)
  end_case
end_proc:

