// $Date: 2000/11/23 08:57:22 $ $Author: tonner $ $Revision: 1.10 $ 
// tonner, 23/06/98 

/*++
output::MathContent -- Wrapper for Content markup
++*/

MathContent := newDomain(hold(MathContent)):
MathContent::print := x -> extop(x,1):
MathContent::new := 
proc() 
  local cl, doc, aliasList;
begin 
  cl:= clientObject();
  if traperror((
       doc:= cl::document();
       doc::release()
     )) <> 0 
  then // not a calc control
    if length(args()) > 300 then
      error("too big")
    end_if;
  end:
  if args() = null() then
    new(dom, hold(``))
  else
    aliasList := _pref(hold(Alias));
    if testtype(aliasList, DOM_LIST) and op(aliasList, 1) = TRUE and
      testtype(op(aliasList, 2), DOM_PROC) then
      Content::setAliasTab(op(aliasList, 2)())
    else
      Content::setAliasTab(table)
    end_if;
    new(dom, Content::new(args())) 
  end_if;
end:

MathContent::expr := x -> Content::expr(extop(x,1)):
MathContent::testtype := FALSE:
MathContent::create_dom := hold(MathContent):

