Pref::floatFormat:=
  funcenv(
           proc(s)
             local oldval;
           begin
             case args(0)
               of 0 do
                 return(_pref(hold(FloatFormat)))
               of 1 do
                 if args(1) = NIL then // set default value 
                   s:= _pref(hold(FloatFormat));
                   _pref(hold(FloatFormat) = "f");
                   return( s )
                 elif not contains({"f", "e", "g", "h", "x"}, s) then
                   error("argument must either be \"f\", \"e\", \"g\" or \"x\"")
                 else
                   oldval := _pref(hold(FloatFormat));
                   _pref(hold(FloatFormat) = _if(s = "x", "h", s));
                   return( oldval )
                 end_if
             otherwise
               error("wrong no of args (expecting \"f\", \"e\", \"g\" or \"x\")")
             end_case
           end_proc):

Pref::floatFormat:= slot(Pref::floatFormat, "info",
                         "Controls the output of objects of type DOM_FLOAT."):

Pref::floatFormat:= slot( Pref::floatFormat, "default", "g" ):
