Pref::matrixSeparator:= funcenv(
    proc(s)
    begin
        case args(0) 
        of 0 do
            return( _pref(hold(MatrixSeparator)) )
        of 1 do
            if args(1) = NIL then // set default value 
               s:= _pref(hold(MatrixSeparator)); 
	       _pref(hold(MatrixSeparator) = ", ");
               return( s )
            elif domtype(s) <> DOM_STRING or length(s) > 4 then
                error("string with length < 5 expected")
            else
                _pref(hold(MatrixSeparator)); 
		_pref(hold(MatrixSeparator) = s); 
               return( %2 )
            end_if
        otherwise
            error("wrong no of args")
        end_case
    end_proc):
Pref::matrixSeparator:= slot(Pref::matrixSeparator,
"info","Sets the output separator of matrices."):

Pref::matrixSeparator:= slot( Pref::matrixSeparator, "default", ", " ):

// end of file 
