
Pref::warnDeadProcEnv:= funcenv(
    proc(v)
    begin
        case args(0) 
        of 0 do
            return( _pref(hold(WarnDeadProcEnv)) )
        of 1 do
            if args(1) = NIL then // set default value 
               v:= _pref(hold(WarnDeadProcEnv));
	       _pref(hold(WarnDeadProcEnv) = FALSE);
               return( v )
            elif not contains( {TRUE,FALSE},v ) then
               error("expecting TRUE or FALSE")
            else
               _pref(hold(WarnDeadProcEnv));
	       _pref(hold(WarnDeadProcEnv) = v); 
               return( %2 )
            end_if
        otherwise
            error("wrong no of args (expecting TRUE or FALSE)")
        end_case
    end_proc):

Pref::warnDeadProcEnv:= slot(Pref::warnDeadProcEnv,
    "info","Warn about use of lexical closure."):

Pref::warnDeadProcEnv:= slot( Pref::warnDeadProcEnv, "default", FALSE ):

// end of file 
