
prog::RINT:= table():

// Initialisieren aller Funktionen /////////////////////////////////////////////
prog::init:=
  proc(FUN = null(), OPT = null())
    //option remember;
    local EN;
    save LEVEL, MAXDEPTH;
  begin
    if FUN = hold(All) then
      if OPT = hold(All) then prog::initall() end_if;
      // and again
      return(prog::initall())
    end_if;
    
    //
    if contains(prog::RINT, FUN) then
      if prog::RINT[FUN] = 0 then
      userinfo(Text, 11..11, "NOT else init entry ".FUN);
      return()
      else
        sysassign(prog::RINT[FUN], prog::RINT[FUN] - 1)
      end_if
    else
      sysassign(prog::RINT[FUN], 1)
    end_if;

    LEVEL:= 100; MAXDEPTH:= 5000;
    if domtype(FUN) = stdlib::LoadProc then
      FUN:= context(FUN)
    end_if;

    case domtype(context(FUN))
      of DOM_FUNC_ENV do
        FUN:= context(FUN);
	prog::init(op(FUN, 1));
	prog::init(op(FUN, 2));
	if domtype(op(FUN, 3)) = DOM_TABLE then
	  for EN in map(op(op(FUN, 3)), X->op(X, 1)) do
	    userinfo(Text, 11..11, "init entry ".prog::getname(FUN)."::".EN);
	    prog::init(context(slot(FUN, EN)))
	  end_for
	end_if;
	break
      of DOM_EXPR do
      of DOM_DOMAIN do
        FUN:= context(FUN);
	if not contains({AxiomConstructor, CategoryConstructor, DomainConstructor,
			 Dom, Ax, Cat},
			context(FUN)) then
          // stdlib::PROTECTED entaelt auch module
	  for EN in {op(prog::Entries(FUN))} minus {"PROTECTED"} do
	    userinfo(Text, 11..11, "init entry ".prog::getname(FUN)."::".EN);
	    prog::init(context(slot(FUN, EN)))
	  end_for
	end_if;
	break
      otherwise
	userinfo(Text, 11, "init ".prog::getname(FUN)." of type ".expr2text(domtype(context(FUN))));
	context(FUN);
    end_case;
    null()
  end_proc:

prog::initall:=
  proc()
    local GF, DF;
  begin
    // DOM_PROC /////////////////////////////////////////////////////////////
    userinfo(Text, 1, "pre-init all DOM_PROC");
    map(sort([op(select(stdlib::anames(3), (X)->(type(context(X)) = DOM_PROC)))],
	     (X, Y)->(expr2text(X)<expr2text(Y))),
	prog::init);
    // DOM_FUNC_ENV /////////////////////////////////////////////////////////
    userinfo(Text, 1, "pre-init all DOM_FUNC_ENV");
    map(sort([op(select(stdlib::anames(3), (X)->(type(context(X)) = DOM_FUNC_ENV)))],
	     (X, Y)->(expr2text(X)<expr2text(Y))),
	prog::init);
    // DOM_DOMAIN ///////////////////////////////////////////////////////////
    userinfo(Text, 1, "pre-init most DOM_DOMAIN");
    GF:= sort([op(select(stdlib::anames(3), (X)->(type(context(X)) = DOM_DOMAIN)))],
	      (X, Y)->(expr2text(X)<expr2text(Y)));
    for DF in GF do
      DF:= context(DF);
      if domtype(DF) = DOM_DOMAIN then
	//if contains(context(DF), "constructor") then
	  prog::init(DF);
	  sysdelete(prog::init(DF))
	//end_if
      end_if
    end_for;
    null()
  end_proc:

prog::Entries:=
  proc(DOM)
    local AE;
  begin
    if domtype(DOM) = DOM_DOMAIN then
      if (AE:= ((context(DOM))::allEntries())) <> FAIL then
        AE:= sort([op(AE minus (context(DOM))::undefinedEntries())])
      else
        AE:= sort([map(op(context(DOM)), (X)->(op(X, 1)))]);
      end_if
    elif domtype(DOM) = DOM_FUNC_ENV then
      if domtype((AE:= op(context(DOM), 3))) = DOM_TABLE then
	if nops(AE) > 1 then
	  AE:= sort([map(op(AE), (X)->(op(X, 1)))])
	else
	  AE:= [op(AE, [1, 1])]
	end_if
      else
	AE:= []
      end_if
    else
      AE:= []
    end_if;
    AE
  end_proc:

prog::isGlobal:=
  proc(INDET)
  begin
    contains(level(stdlib::ENVIRONMENT_VARIABLES, 1) union stdlib::SYSTEM_CONSTANTS
	     union stdlib::LIBRARY_CONSTANTS union stdlib::OPTIONS
             union stdlib::PROTECTED
	     union prog::getcheckglobals(), INDET)
  end_proc:

