
prog::getname:=
  proc(FUN)
    local NAME;
  begin
    NAME:= expr2text(FUN);
    FUN:= context(FUN);
    case domtype(FUN)
      of DOM_VAR do
	if prog::VNM([op(FUN)]) <> FAIL then
	  expr2text(prog::VNM([op(FUN)]))
	else
	  NAME;
	end_if;
	break
      of DOM_PROC do
	if op(FUN, 6) = NIL or op(FUN, 6) = "" then
          "(noname)"
        else
          if domtype(op(FUN, 6)) = DOM_VAR then
	    if prog::VNM([op(op(FUN, 6))]) <> FAIL then
	      expr2text(prog::VNM([op(op(FUN, 6))]))
	    else
	      expr2text(op(FUN, 6))
	    end_if
          elif domtype(op(FUN, 6)) = DOM_STRING then
            op(FUN, 6)
	  else
	    expr2text(op(FUN, 6))
	  end_if
	end_if;
        break
      of DOM_IDENT do
      of DOM_EXEC do
        expr2text(FUN); break
      of DOM_FUNC_ENV do
	if op(FUN, 2) <> NIL then
	  prog::getname(op(FUN, 2))
        elif domtype(op(FUN, 3)) = DOM_TABLE then
          if contains(op(FUN, 3), "print") then
	    op(FUN, 3)["print"]
	  elif contains(op(FUN, 3), "type") then
	    op(FUN, 3)["type"]
	  else
	    prog::getname(op(FUN, 1))
	  end_if
	else
	  prog::getname(op(FUN, 1))
	end_if; break
      of DOM_DOMAIN do
	if domtype(FUN::key) = DOM_STRING then
	  FUN::key
	else
	  NAME
	end_if;
	break
      of DOM_STRING do
        FUN;
        break
      otherwise
        if contains(FUN::dom, "expr2text") then
          FUN::dom::expr2text(FUN)
        elif contains(FUN::dom, "print") then
          FUN::dom::print(FUN)
        else
          NAME
        end_if
    end_case
  end_proc:
