
////////////////////////////////////////////////////////////////////////////////
// Interface: setcheckglobals
////////////////////////////////////////////////////////////////////////////////

prog::setcheckglobals:=
  proc(FUN = null(), GLOBAL = null())
    //option hold;
  begin
    if FUN = null() then
      prog::getcheckglobals()
    elif GLOBAL = null() then
      prog::getcheckglobals(FUN)
    else
      userinfo(Text, 6..9, "set global for ".prog::getname(FUN).": ".expr2text(GLOBAL));
      userinfo(Text, 14, "set global for ".prog::getname(FUN).": ".expr2text(GLOBAL));
      sysassign(prog::globalIdents,
		table(op(prog::globalIdents), prog::getname(FUN) = context(GLOBAL)));
      null()
    end_if
  end_proc:

prog::getcheckglobals:=
  proc(FUN = null())
    //option hold;
    local i;
  begin
    if FUN = null() then
      if nops(context(prog::PATH)) > 0 then 
	_union(prog::getcheckglobals(op(context(prog::PATH), i))
	       $ i=1..nops(context(prog::PATH)),
	       prog::getcheckglobals(hold(All)))
      else
	{}
      end_if
    else
      if contains(prog::globalIdents, FUN) then
	prog::globalIdents[FUN]
      else
        {}
      end_if
    end_if
  end_proc:
