
// expr <, Quiet >

prog::exprtree:=
  proc(ex, opt = null())
    local rtree;
  begin
    rtree:=
      proc(ex)
        local i, tree;
      begin
        if domtype(ex) = DOM_EXPR then
          tree:= [];
          tree:= append(tree, op(ex, 0));
          for i from 1 to nops(ex) do
            tree:= append(tree, rtree(op(ex, i)))
          end_for
        else
          return(ex)
        end_if
      end_proc:

    if domtype(ex) = DOM_EXPR then
      rtree:= adt::Tree(rtree(ex))
    else
      rtree:= adt::Tree([ex])
    end_if;
    if opt <> hold(Quiet) then rtree::print() end_if;
    rtree
  end_proc:
