// loscht Eigenschaften - unassume(ident, < prop >) 
property::unassume:=
	proc(ident = hold(Global), prop = null())
	  local _pr, idprops;
	begin
          if testargs() then
//        if testtype(args(), Type::Sequence({DOM_IDENT,
//                                            Type::ListOf(DOM_IDENT),
//                                            Type::SetOf(DOM_IDENT)}, [Type::Property]))
               

            if domtype(ident) <> DOM_IDENT and
               not(testtype(ident, Type::ListOf(DOM_IDENT))
                   or testtype(ident, Type::SetOf(DOM_IDENT))) then
              error("wrong type of first argument (DOM_IDENT expected)")
            elif args(0) > 1 and prop::dom::prop <> TRUE then
              error("illegal second argument (property expected)")
            elif args(0) > 2 then
              error("too many arguments")
            end_if
          end_if;

	  //property::reset(0):
	  if contains({"_less", "_leequal", "_equal", "_unequal"},
		      type(ident)) then
	    return(property::delrel(args()))
	  end_if;
          if type(ident) = "_in" then
            return(property::unassume(op(ident, 1)))
          end_if;
	  if args(0) = 0 then
            return(property::unassume(hold(Global)))
	  end_if;
	  if args(0) = 1 then
	    if contains({DOM_SET, DOM_LIST}, domtype(args(1))) then
	      for _pr from 1 to nops(args(1)) do
	        property::unassume(extop(args(1), _pr))
	      end_for;
	      return()
            elif domtype(context(ident)) = DOM_IDENT
                 and not contains(Type::ConstantIdents, context(ident)) then
              protected(hold(Global), hold(None));
	      properties(ident, FAIL);
              protected(hold(Global), hold(Error));
	      userinfo(9, "Removing all properties.");
	      return()
            elif ident::dom::prop = TRUE then
              return(property::unassume(hold(Global)))
	    else
	      return(FAIL)
	    end_if
	  end_if;
	  idprops:= properties(ident);

	  //_pr:= eval(subs(idprops, prop = null()));
	  _pr:= idprops and not(prop);
	  if nops(_pr) < nops (idprops) then
            protected(hold(Global), hold(None));
	    if property::Fail(_pr) then
	      properties(ident, FAIL)
	    else
	      properties(ident, _pr)
	    end_if;
            protected(hold(Global), hold(Error));
	    userinfo(9, "Removing: " . expr2text(prop));
	    return(_pr)
	  end_if;
	  userinfo(9, "No property: " . expr2text(prop));
	  return(FAIL)
	end_proc:

// (rel, _Op) loscht eine Relation 
property::delrel:=
	proc(rel, _Op = null())
	  local st, __op, op1, op2, __ret;
	begin
	  //property::reset(0):
	    //  0   1   2   3   4   5   6   7   8  
	    // t-t/i-t/e-t/t-i/i-i/e-i/t-e/i-e/e-e 
	  st:= property::isxRel(rel);

	  op1:= _if(domtype(op(rel, 1)) = DOM_IDENT, op(rel, 1), null());
	  op2:= _if(domtype(op(rel, 2)) = DOM_IDENT, op(rel, 2), null());
	  __ret:= null();
	  __op:= op(rel, 0);
	  if domtype(op1) <> DOM_NULL then
	    __ret:= property::unassume(op1, property::Rel(__op,
					                 op(rel, 2)), _Op)
	  end_if;
	  if domtype(op2) <> DOM_NULL then
	    __ret:= property::unassume(op2, property::Rel(-__op,
					                 op(rel, 1)), _Op)
	  end_if;
	  __ret
	end_proc:

unassume:= property::unassume:

