// $Date: 2000/11/28 11:45:37 $ $Author: bij $ $Revision: 1.39 $

// Standard-Operator: Domain, Operator, Funktion fur zwei Argumente 
property::_Op:=
        proc(_dom, _op, _proc, prop1, prop2)
          local ARGS, _ret, _rule, _dom2, OPT;
          //option remember;
        begin
          if args(0) = 4 then return(prop1) end_if;
          if args(0) = 5 then

            if _op = _or then
              if prop1 = property::Null then
                return(prop2)
              elif prop2 = property::Null then
                return(prop1)
              end_if
            end_if;

            if property::Fail(prop1) then
              return(prop1)
            end_if;
            if property::Fail(prop2) then
              return(prop2)
            end_if;

            if map({prop1::dom, prop2::dom}, slot, "prop") = {TRUE} then
              _dom2:= (args(_if(_dom = prop1::dom, 5, 4)))::dom
            else
              _dom2:= _dom
            end_if;

            if property::OWNRULES then
              _rule:= property::Prule(_op, prop1, prop2);
              //userinfo(9, "Rule?");
              _ret:= property::_getrule(_dom, _rule);
              if _ret <> FAIL then
                return(_ret)
              end_if;
  
              if (_dom2 <> _dom) then
                _ret:= property::_getrule(_dom2, _rule);
                if _ret <> FAIL then
                  return(_ret)
                end_if;
              end_if;
              //userinfo(9, "Function?");
              _ret:= property::_getfunc(_dom, _rule);
              if _ret <> FAIL then
                return(_ret)
              end_if;
              if (_dom2 <> _dom) then
                _ret:= property::_getfunc(_dom2, _rule);
                if _ret <> FAIL then
                  return(_ret)
                end_if;
              end_if;
            end_if;
            
            //userinfo(9, "Convert?");
            // informativeres Domain
            if contains(property::incl, type(prop2)) then
              if contains(property::incl[type(prop2)], type(prop1)) then
                // vertausche Domains
                OPT:= _dom;
                _dom:= _dom2;
                _dom2:= OPT;
                _proc:= _op
              end_if
            end_if;

            OPT:= hold(Exact);
            repeat
              // Berechnung in _dom
              ARGS:= property::convertArgs(_dom, prop1, prop2, OPT);
              if op(ARGS, 1) = TRUE then
                //userinfo(9, "Own proc");
                _ret:= _proc(op(ARGS, 2..3));
                if type(_ret) <> expr2text(_op) then
                  return(_ret)
                end_if
              elif op(ARGS, 1) <> FALSE then
                //userinfo(9, "Return more");
                return(context(_op)(op(ARGS, 2..3)))
              end_if;
              
              // Berechnung in _dom2
              if _dom <> _dom2 then
                ARGS:= property::convertArgs(_dom2, prop1, prop2, OPT);
                if op(ARGS, 1) = TRUE then
                  if contains(_dom2, expr2text(_op)) then
                    _ret:= slot(_dom2, expr2text(_op))(op(ARGS, 2..3));
                    if type(_ret) <> expr2text(_op) then
                      return(_ret)
                    end_if
                  end_if
                end_if
              end_if;
              
              // Verknupfung in gemeinsamer Obermenge
              if (_rule:= property::Sset(type(prop1), type(prop2))) <> FAIL then
                ARGS:= property::convertArgs(slot(property, _rule),
                                             prop1, prop2, OPT);
                if op(ARGS, 1) = TRUE then
                  _ret:= property::_Op(slot(property, _rule),
                                       _op, _op, op(ARGS, 2..3));
                  if type(_ret) <> expr2text(_op) then
                    return(_ret)
                  end_if
                end_if
              end_if;
  
              // again with sloppy convertion
              if OPT = hold(Exact) then
                OPT:= hold(Sloppy)
              else
                OPT:= FALSE
              end_if
            until OPT = FALSE end_repeat;

            return(subsop(subsop(ARGS, 1 = null()), 0 = _op, Unsimplified))
            // fallback
            //return(subsop(args(4..5), 0 = _op, Unsimplified))
          else
            //userinfo(9, "More than two Operands - ".expr2text(args(), args(0)));

            // collect constants - splitting "no-properties"
            _ret:= split([args(4..args(0))], X -> contains(X::dom, "prop"));
            if nops(op(_ret, 2)) > 1 then
              _rule:= eval(_op(op(op(_ret, 2))));
              if domtype(_rule) <> DOM_EXPR and domtype(op(_ret, 2)) = DOM_EXPR then
                // one "no-properties"
                return(property::_Op(_dom, _op, _proc, op(op(_ret, 1)), _rule))
              elif nops(_rule) < nops(op(_ret, 2)) then
                // less "no-properties"
                return(property::_Op(_dom, _op, _proc, op(op(_ret, 1)), op(_rule)))
              end_if
            end_if;
            return(property::Op(_op, args(4..args(0))))
          end_if
          
        end_proc:

// Standard-Auswertung fur mehr als zwei Parameter 
// Operator, Argumente (min. 3 - _exprseq) 
property::Op:=
        proc()
          local pr, ret, Ret, _T, _op, i, OFF;
        begin
          if args(0) < 4 then
            //userinfo(9, "Less than three operands");
            return(eval(args(1))(args(2..args(0))))
          end_if;

          _T:= expr2text(args(1));
          _op:= args(1);
          pr:= [args(2..args(0))];

          // keine properties
          pr:= split(pr, X -> contains(X::dom, "prop"));
          OFF:= op(pr, 2);
          // collect constants - splitting "no-properties" -> _Op
//           if nops(OFF) > 1 then
//             OFF:= _op(op(OFF));
//             if domtype(OFF) = DOM_EXPR then
//               OFF:= [op(OFF)]
//             else
//               OFF:= [OFF]
//             end_if
//           end_if;

          if nops(pr) + nops(OFF) <= 2 then
            return(eval(_op(op(pr), op(OFF))))
          end_if;

          pr:= op(pr, 1);
          if nops(pr) > 1 then
            // gleiches Domain
            pr:= sort(pr, (X,Y)->sysorder(X, Y));
            // interne Sortierung zur besseren Vereinfachung
            pr:= op(sort(pr, (X,Y)->if type(X) = type(Y) and X::dom::_sort <> FAIL then
                                      X::dom::_sort(X,Y)
                                    else
                                      FALSE
                                    end_if));
            
            // zuerst: nur Operanden gleichen Domains
            ret:= op(pr, 1);
            for i from 2 to nops(pr) do
              if domtype(ret) = DOM_EXPR then
                if type(op(ret, nops(ret))) = type(op(pr, i)) then
                  Ret:= _op(op(ret, nops(ret)), op(pr, i));
                  if domtype(Ret) = DOM_EXPR then
                    ret:= op(ret, 1..nops(ret)-1), op(Ret)
                  else
                    ret:= op(ret, 1..nops(ret)-1), Ret
                  end_if
                else
                  ret:= op(ret), op(pr, i)
                end_if
              else
                if type(ret) = type(op(pr, i)) then
                  Ret:= _op(ret, op(pr, i));
                  if domtype(Ret) = DOM_EXPR then
                    ret:= op(Ret)
                  else
                    ret:= Ret
                  end_if
                else
                  ret:= ret, op(pr, i)
                end_if
              end_if
            end_for;
          else
            ret:= op(pr)
          end_if;

          if type(ret) <> "_exprseq" then
            if OFF <> [] then
              return(subsop(hold(id)(ret, op(OFF)), 0 = _op, Unsimplified))
            else
              return(ret)
            end_if
          end_if;

          // dann: nacheinander
          pr:= ret, op(OFF);
          ret:= op(pr, 1);
          for i from 2 to nops(pr) do
            if domtype(ret) = DOM_EXPR then
              Ret:= _op(op(ret, nops(ret)), op(pr, i));
              if domtype(Ret) = DOM_EXPR then
                ret:= op(ret, 1..nops(ret)-1), op(Ret)
              else
                ret:= op(ret, 1..nops(ret)-1), Ret
              end_if
            else
              Ret:= _op(ret, op(pr, i));
              if domtype(Ret) = DOM_EXPR then
                ret:= op(Ret)
              else
                ret:= Ret
              end_if
            end_if
          end_for;

          if domtype(ret) <> DOM_EXPR then return(ret) end_if;
          //userinfo(9, "More than one-operand result");
          return(subsop(hold(id)(ret), 0 = _op, Unsimplified))
        end_proc:

// Standard-Test-/Konvertierungsroutine fur Domain-Operationen
// ARGS: Ziel-Domain, args(1), args(2)
property::convertArgs:=
        proc(_dom, op1, op2, OPT = hold(Exact))
          local _rg1, _rg2, _op;
        begin
          _op:= TRUE;
          
          _rg1:= op1;
          if op1::dom <> _dom then
            _rg1:= property::_convert(OPT, op1, _dom);
            if _rg1::dom <> _dom then
              if (op1 <> _rg1) and
                 not(contains({property::Null, FAIL}, _rg1)) then
                _op:= UNKNOWN
              else
                _op:= FALSE;
                _rg1:= op1
              end_if
            end_if
          end_if;
          
          _rg2:= op2;
          if op2::dom <> _dom then
            _rg2:= property::_convert(OPT, op2, _dom);
            if _rg2::dom <> _dom then
              if (op2 <> _rg2) and
                 not(contains({property::Null, FAIL}, _rg2)) then
                _op:= UNKNOWN
              else
                if _op <> UNKNOWN then
                  _op:= FALSE;
                  _rg2:= op2
                end_if
              end_if
            end_if
          end_if;

          if _op <> TRUE and (_rg1 = op1) and (_rg2 = op2) then
            _op:= FALSE
          end_if;

          return(_op, _rg1, _rg2)
        end_proc:

// Lazy-map(_expA, _proc, args...) 
property::lzeval:=
        proc(_expA, _proc)
          local _ok, _oko, _okp;
        begin
          if type(_expA) = "_and" then
            _ok:= TRUE;
            _oko:= _or
          else // type(_expA) = "_or" then
            _ok:= FALSE;
            _oko:= _and
          end_if;
          _okp:= map({op(_expA)}, _proc, args(3..args(0)));
          if nops(_okp) = 1 then
            return(op(_okp))
          elif _ok = TRUE then
            return(_oko(op(_okp)))
          else
            return(UNKNOWN)
          end_if
        end_proc:

property::_Op:= prog::remember(property::_Op, property::depends):
