// $Date: 2000/11/30 16:05:18 $ $Author: bij $ $Revision: 1.44 $

// gibt alle Eigenschaften aus
property::getprop:=
        proc(ex = hold(Global))
          local ret, ret2, lev;
        begin
          if testargs() then
            if args(0) > 1 then
              error("wrong number of arguments")
            end_if
          end_if;

          //userinfo(1, "*** getprop --> ".expr2text(args()));
          property::reset(1);

          if property::RESET > 1 then // inline of recursion
            lev:= 0;
            ret:= property::_getprop(ex)
          elif property::NoErrors then
            lev:= 0;
            warning("Don't forget to call 'property::reset()' after any error!");
            ret:= property::_getprop(ex)
          else
            lev:= traperror((ret:= property::_getprop(ex);
                             // probeweise Faktorisieren - nur in Interface-Funktion
                             if args(0) > 0 then
                               if not contains({ex, FAIL, NIL}, (ret2:= property::Factor(ex))) then
                                 if property::implies((ret2:= property::_getprop(ret2)), ret) = TRUE then
                                   ret:= ret2
                                 end_if
                               end_if
                             end_if;))
          end_if;
          if lev > 0 then
            sysassign(property::RESET, 0);
            property::reset();
            lasterror()
          end_if;

          property::reset(-1);
          //userinfo(1, "*** getprop <-- ".expr2text(ret));
          return(ret)
        end_proc:

// // (rel) gibt eine Relation (Typ `Rel') zuruck 
// property::rel:=
//         proc(_rel, _dir = "<")
//         begin
//           if contains({"<", "<=", _less}, _dir) then
//             return(property::Rel(op(_rel, 0), op(_rel, 2)))
//           else
//             return(property::Rel(-op(_rel, 0), op(_rel, 1)))
//           end_if
//         end_proc:

property::getfunc:=
        proc(ex)
          local i;
        begin
          if nops(ex) = 1 and (i:= contains([hold(Re), hold(Im)], op(ex, 0))) > 0 then
            return((op([Re, Im], i))(property::_getprop(op(ex, 1))))
          end_if;
//           if nops(ex) = 1 /*and domtype(op(ex)) = DOM_IDENT then
//             if (i:= contains([hold(Re), hold(Im)], type(ex))) > 0 then
//               return((op([Re, Im], i))(property::_getprop(op(ex, 1))))
//             end_if
//           end_if;
          //fprint(0, map, ex, map(ex, property::_getprop));
          //return(map(ex, property::_getprop))
          FAIL
        end_proc:

// intern --- remember
property::_getprop:=
        proc(ex = hold(null()), _to = FAIL, Opt = FAIL)
          local ret, _f, GLOBAL;
        begin
          if domtype(ex) = DOM_IDENT then
            //return(property::convert_to(properties(ex), DOM_IDENT))
            if properties(ex) <> FAIL then
              ret:= property::convert_to(op(properties(ex), 2), _to)
            else
              ret:= property::convert_to(ex, _to)
            end_if;
            if ret::dom::getprop <> FAIL then
              ret:= ret::dom::getprop(ret, ex)
            end_if
          elif domtype(ex) = DOM_EXPR then
            if (ret:= property::getfunc(ex)) = FAIL then
              ret:= property::Ex2Px(ex)
            end_if;
            if domtype((_f:= eval(op(ex, 0)))) = DOM_FUNC_ENV and
               (_f:= slot(_f, "getprop")) <> FAIL then
              ret:= property::convert_to(_f(op(ex), _to), _to)
            else
              ret:= property::convert_to(eval(ret), _to, Opt)
            end_if
          else
            ret:= (eval(property::convert_to(ex, _to)))
          end_if;
          if ret = property::Unknown or ret = hold(Global) then
            ret:= hold(Global)
          end_if;
          if (GLOBAL:= properties(hold(Global))) <> FAIL then
            if testtype(ret, Type::Property) then
              if property::implies(ret, op(GLOBAL, 2)) <> TRUE then
                ret:= ret and op(GLOBAL, 2)
              end_if
            elif not testtype(ret, Type::Constant) then
              ret:= op(GLOBAL, 2)
            end_if
          end_if;
          //if ret = FAIL and Opt = hold(Exact) then
          //  ret:= property::_getprop(ex, _to, hold(Sloppy))
          //end_if;
          if ret = FAIL then
            ret:= ex
          elif not(testtype(ret, Type::Property)) then
            if domtype(ex) = DOM_EXPR and domtype((ex:= eval(op(ex, 0)))) = DOM_FUNC_ENV and
               slot(ex, "minprop") <> FAIL then
              ret:= slot(ex, "minprop")
            end_if
          end_if;
          ret
        end_proc:

getprop:= property::getprop:

property::_getprop:=
  prog::remember(property::_getprop, property::depends, hold(PreventRecursion), id):
