// $Date: 2000/11/30 19:01:59 $ $Author: bij $ $Revision: 1.50 $

// Mengen statt Eigenschaften
property::SET:= FALSE:

// Werte von property::isxRel
alias(t_t = 0):alias(i_t = 1):alias(e_t = 2):alias(p_t = 3):alias(t_i = 4):alias(i_i = 5):
alias(e_i = 6):alias(p_i = 7):alias(t_e = 8):alias(i_e = 9):alias(e_e = 10):
alias(p_e = 11):alias(t_p = 12):alias(i_p = 13):alias(e_p = 14):alias(p_p = 15):

// Vereinfachungen fur property::simpex
property::simpex:=
  proc(BL = TRUE)
    local SPLIT, RET, LIT, R, i;
  begin
    // zurucksetzen
    sysassign(property::SET, FALSE);

    BL:= expand(BL);

    if domtype(BL) <> DOM_EXPR then
      return(property::_simpex(BL))
    end_if;

    SPLIT:= split([op(BL)], X->bool(contains({"_and", "_or", "_not"}, type(X))));
    // Literale vereinfachen
    if nops(op(SPLIT, 2)) > 0 then
      R:= property::_simpex(op(BL, 0)(op(op(SPLIT, 2))))
    else
      R:= null()
    end_if;
    if R = TRUE then
      if contains({"_or", "_not"}, type(BL)) then
        return(TRUE)
      end_if
    elif R = FALSE then
      if contains({"_not", "_and"}, type(BL)) then
        return(FALSE)
      end_if
    end_if;

    LIT:= R;
    if nops(op(SPLIT, 1)) = 0 then //keine Teilbaume
      return(R)
    else
      RET:= op(SPLIT, 1);
      for i from 1 to nops(RET) do
        R:= property::simpex(op(RET, i));
        if R = TRUE then
          if contains({"_or", "_not"}, type(BL)) then
            return(TRUE)
          end_if
        elif R = FALSE then
          if contains({"_not", "_and"}, type(BL)) then
            return(FALSE)
          end_if
        end_if;
        RET:= subsop(RET, i = R, Unsimplified)
      end_for
    end_if;

    property::_simpex(op(BL, 0)(LIT, op(RET)));
  end_proc:

property::_simpex:=
        proc(EX)
          local TEST, k, i, M, IN, RET, R;
        begin
          if contains({TRUE, FALSE, UNKNOWN}, EX) then
            return(EX)
          end_if;

          TEST:=
            proc(X)
              local k;
            begin
              if contains({"_and", "_or"}, type(X)) then
                UNKNOWN
              elif type(X) = "_not" then
                not TEST(op(X))
              elif type(X) = "_in" then
                // discont:
                if type(op(X, 2)) <> "function" then
                  property::_is(op(X, 1), op(X, 2))
                else
                  UNKNOWN
                end_if
              elif property::Fail(X) then
                UNKNOWN
              elif property::isxRel(X) = t_t and traperror((k:= bool(X))) = 0 then
                k
              elif nops(indets(X) minus Type::ConstantIdents) = 0
                   and contains({TRUE, FALSE}, (k:= is(X))) then
                k
              elif domtype(X) = DOM_IDENT and property::_getprop(X) = X then
                UNKNOWN
              elif nops((k:= indets(X))) = 1                 // PI, E, EULER, CATALAN
                   and (property::_getprop(op(k)) = op(k) or testtype(X, Type::Constant))
                   and contains({TRUE, FALSE}, (k:= property::_is(X))) then
                k
              elif contains({TRUE, FALSE}, (k:= property::isrel(X))) then
                k
              else
                UNKNOWN
              end_if
            end_proc;

          if type(EX) = "_not" then
            return(_not(property::_simpex(op(EX))))
          elif type(EX) = "_and" then
            RET:= map(EX, X->op([hold(null)(), FALSE, X], contains([TRUE, FALSE, UNKNOWN], TEST(X))));
            if has(RET, FALSE) then return(FALSE) end_if
          elif type(EX) = "_or" then
            RET:= map(EX, X->op([TRUE, hold(null)(), X], contains([TRUE, FALSE, UNKNOWN], TEST(X))));
            if has(RET, TRUE) then return(TRUE) end_if
          else
            if (k:= TEST(EX)) <> UNKNOWN then
              return(k)
            else
              RET:= EX
            end_if
          end_if;

          RET:= eval(RET);

          if RET = null() then
            return(op([TRUE, FALSE], contains([hold(_and), hold(_or)], op(EX, 0))))
          end_if;

	  IN:= indets(RET) minus Type::ConstantIdents; //{PI, E, EULER, CATALAN};
	  if nops(IN) > 1 and contains({"_and", "_or", "_not"}, type(RET))
             and map({op(EX)}, type) intersect {"_and", "_or", "_not"} = {} then
            M:= null();
            for k in IN do
              R:= property::Ex2Rx(select(RET, has, k), k);
              if (i:= contains([Type::Real, property::Null], R))
                  = contains(["_or", "_and"], type(EX)) then
                return(op([TRUE, FALSE], i))
              end_if;
              //R:= property::_simpconst(R, k);
              M:= M, [R, k]
            end_for;
            R:= op(EX, 0)(map(M, X->property::simpexpr(op(X, 1), op(X, 2))))
          elif nops(IN) = 0 then
            if traperror((IN:= bool(RET))) = 0 then
              return(IN)
            elif traperror((IN:= bool(float(RET)))) = 0 then
              return(IN)
            else
              return(RET)
            end_if
          else
	    R:= property::simpexpr(property::Ex2Rx(RET, op(IN)), op(IN));
            //R:= property::_simpconst(R, op(IN));
          end_if;

	  if (i:= contains([Type::Real, property::Null], R)) > 0 then
            return(op([TRUE, FALSE], i))
          elif R = UNKNOWN then
            R:= RET
          else
            R:= eval(R)
          end_if;
          if property::SET then
            property::prop2set(R)
          else
            R
          end_if
	end_proc:

// prop -> expr
property::simpexpr:=
	proc(PR, ident)
          local iv, rg;
        begin
          if PR = Type::Complex or PR = C_ then
            return(TRUE)
          end_if;
          if type(PR) = "IV" then
            if PR = property::IV(-infinity, infinity) then
              Type::Real
            else
              iv:= property::IV::Rel(PR, hold(Approx));
              rg:= property::IV::NRange(PR);
              if property::NRange::is(rg, Type::Rational) = TRUE then
                rg:= ident in rg
              else
                rg:= TRUE
              end_if;
              if contains({"_and", "_or", "_not"}, type(iv)) then
                map(iv, property::simpexpr, ident) and rg
              elif rg <> TRUE and property::IV::NRange(PR, hold(Exact)) <> FAIL then
                rg
              else
                property::simpexpr(iv, ident) and rg
              end_if
            end_if
          elif type(PR) = "Rel" then
            rg:= property::Rel::expr(PR, ident);
            if type(rg) = "_equal" then
              _equal(op(sort([op(rg)], sysorder)))
            else
              rg
            end_if
          elif contains({solvelib::BasicSet, Dom::ImageSet, "NRange", "Complex"}, type(PR)) then
            ident in PR
          elif type(PR) = "_in" then
            PR
          elif contains({"_and", "_or", "_not"}, type(PR)) then
            if type(PR) = "_or" and hastype(PR, "IV") then
              map(map(PR, X -> if type(X) = "IV" then property::IV::Rel(X) else X end_if),
                  property::simpexpr, ident)
            else
              map(PR, property::simpexpr, ident)
            end_if
          else
            PR
          end_if
	end_proc:

// simplify  Range and Constants
property::_simpconst:=
        proc(EX, ident)
          local RG, RET, IN;
        begin
	  if contains({"_and", "_or"}, type(EX)) then
            RET:= select(EX, has, ident);
            if contains({"_and", "_or"}, type(RET)) then
              IN:= select(RET, hastype, "_in");
              //REL:= select(RET, X -> contains({"_equal", "_unequal"}, type(X)));
              if IN = TRUE then
                IN:= [Type::Real]
              elif type(IN) <> "_in" then
                IN:= map([op(IN)], op, 2)
              else
                IN:= [op(IN, 2)]
              end_if;

              for RG in IN do
                EX:= map(EX, property::_simprel, ident, RG)
              end_for
            end_if
          end_if;
          EX
        end_proc:

// relation
property::_simprel:=
        proc(REL, ident, RANGE)
        begin
          if not has(REL, ident) then
            REL
          elif contains({"_equal", "_unequal"}, type(REL)) then
            if testtype(op(REL, 1), RANGE) or testtype(op(REL, 2), RANGE) then
              REL
            else
              null()
            end_if
          elif contains({"_leequal", "_less"}, type(REL)) then
            if testtype(op(REL, 1), RANGE) or testtype(op(REL, 2), RANGE) then
              REL
            else
              property::simpexpr(property::_simprange(property::Ex2Rx(REL, ident), RANGE), ident)
            end_if
          else
            REL
          end_if
        end_proc:

//
property::_simprange:=
        proc(REL, RANGE)
        begin
          if property::implies(RANGE, Type::Integer) = TRUE then
            property::Rel::Integer(REL)
          //elif property::implies(RANGE, Type::Rational) = TRUE
            
          else // Type::Real
            if testtype(property::Rel::border(REL), Type::Real) then
              REL
            else
              null()
            end_if
          end_if
        end_proc:

property::Ex2Rx:=
	proc(EX, ident = null())
	  local i, rel;
	begin
	  if contains({"_and", "_or"}, type(EX)) then
	    for i from 1 to nops(EX) do
	      EX:= subsop(EX, i = property::Ex2Rx(op(EX, i), ident), Unsimplified)
            end_for;
          // "_not"
	  elif type(EX)  = "_not" then
            rel:= property::Ex2Rx(op(EX), ident);
            if rel <> null() then
              EX:= not rel
            end_if
          // "_in"
          elif type(EX) = "_in" then
            if contains((op(EX, 2))::dom, "set2prop") then
              // solvelib::BasicSet
              // provisorisch: nur exakte Konvertierung
              if (rel:= (op(EX, 2))::dom::set2prop(op(EX, 2)))::dom::prop2set(rel) = op(EX, 2) then
                sysassign(property::SET, TRUE);
                EX:= subsop(EX, 2 = (op(EX, 2))::dom::set2prop(op(EX, 2)))
              else
                return(EX)
              end_if
            end_if;
	    if op(EX, 1) = ident then
              return(op(EX, 2))
            elif type(op(EX, 2)) = "function" then
              return(EX)
	    elif (i:= property::_is(op(EX, 1), op(EX, 2))) <> UNKNOWN then
              return(i)
            else
              return(EX) // !!! hold
            end_if
	  elif testtype(EX, Type::Relation) then
	    if ident <> null() and not(has(EX, ident)) then
              if testtype(EX, Type::Constant) then
                return(EX) // !!! hold
              else // wrong ident
                return() // !!! null()
              end_if
            end_if;
            //if testtype(property::_getprop(ident), Type::Property) then
            if (i:= property::isrel(EX)) <> UNKNOWN then
              return(i)
            end_if;
            //end_if;

            // property::isxRel
            //  0   1   2   3   4   5   6   7   8   9  10  11  12  13  14  15
            // t-t/i-t/e-t/p-t/t-i/i-i/e-i/p-i/t-e/i-e/e-e/p-e/t-p/i-p/e-p/p-p
	    if (i:= property::isxRel(EX)) = i_t then
	      return(property::Rel(op(EX, 0), op(EX, 2)))
	    elif i = t_i then
	      return(property::Rel(-op(EX, 0), op(EX, 1)))
            elif i = t_t then
              return(bool(EX))
            // const < -x => x > -const
            elif (i = e_t and op(EX, 1) = -ident) then
	      return(property::Rel(-op(EX, 0), -op(EX, 2)))
            elif (i = t_e and op(EX, 2) = -ident) then
              return(return(property::Rel(op(EX, 0), -op(EX, 1))))
            // x - y <> 0 => x <> y
//             elif i = e_t
//                  and  then
// 	      return(property::Rel(-op(EX, 0), -op(EX, 2)))
//             elif i = t_e
//                  and then
//               return(return(property::Rel(op(EX, 0), -op(EX, 1))))
            // x + a _rel_ b  =>  x _rel_ b - a
            elif (i = e_t or i = t_e)
                 and hastype(EX, {DOM_INT, DOM_RAT, DOM_FLOAT, DOM_IDENT})
                 and type(op(EX, _if(i = e_t, 1, 2))) = "_plus"
                 and contains({i_t, t_i, e_i, i_e},
                              property::isxRel((rel:= map(EX, _subtract,
                                                          select(op(EX, _if(i = e_t, 1, 2)),
                                                                 X -> contains({DOM_INT, DOM_RAT, DOM_FLOAT},
                                                                               domtype(X))))))) then
              return(property::Ex2Rx(rel, ident))
            // x - y <> 0 => x <> y
            elif (rel:= contains([op(EX)], _if(ident <> null(), ident, FAIL))) > 0 then
              return(property::Rel(op([1, -1], rel)*op(EX, 0), op(EX, 3 - rel)))
            elif (i = e_t or i = t_e)
                 and contains({"_equal", "_unequal"}, type(EX))
                 and op(EX, _if(i = e_t, 2, 1)) = 0
                 and contains({/*"_mult",*/ "_plus"}, type(op(EX, _if(i = e_t, 1, 2))))
                 // expr has one strange identifier
                 and op(map((rel:= split(op(EX, _if(i = e_t, 1, 2)), has, ident)), indets), 2) <> {} then
//               fprint(0, rel, ident, op(map((rel:= split(op(EX, _if(i = e_t, 1, 2)), has, ident)), indets), 2));
//               fprint(0, map(EX, op(EX, _if(i = e_t, [1, 0], [2, 0])), 
//                                                _if(type(op(EX, _if(i = e_t, 1, 2))) = "_mult",
//                                                    _invert, _negate)(op(rel, 2))),
//                      (EX, op(EX, _if(i = e_t, [1, 0], [2, 0])), 
//                                                _if(type(op(EX, _if(i = e_t, 1, 2))) = "_mult",
//                                                    _invert, _negate)(op(rel, 2))));
              return(property::Ex2Rx(map(EX, op(EX, _if(i = e_t, [1, 0], [2, 0])), 
                                               _if(type(op(EX, _if(i = e_t, 1, 2))) = "_mult",
                                                   _invert, _negate)(op(rel, 2))), ident))
//               return(property::Ex2Rx(op(EX, 0)(op(rel, 1),
//                                                _if(type(op(EX, _if(i = e_t, 1, 2))) = "_mult",
//                                                    _invert, _negate)(op(rel, 2))), ident))
            else
	      return(EX)
            end_if
          //elif type(EX) = DOM_IDENT then
          //  return(property::Rel(_equal, EX))
          end_if;
          eval(EX)
        end_proc:

unalias(t_t):unalias(i_t):unalias(e_t):unalias(p_t):unalias(t_i):unalias(i_i):
unalias(e_i):unalias(p_i):unalias(t_e):unalias(i_e):unalias(e_e):unalias(p_e):
unalias(t_p):unalias(i_p):unalias(e_p):unalias(p_p):
