// $Date: 2000/11/29 10:44:20 $ $Author: bij $ $Revision: 1.17 $

alias(t_t = 0):alias(i_t = 1):alias(e_t = 2):alias(p_t = 3):alias(t_i = 4):alias(i_i = 5):
alias(e_i = 6):alias(p_i = 7):alias(t_e = 8):alias(i_e = 9):alias(e_e = 10):
alias(p_e = 11):alias(t_p = 12):alias(i_p = 13):alias(e_p = 14):alias(p_p = 15):

// Auswertung von Relationen
property::isrel:=
  proc(rel)
    local st, ty, rell, ret;
  begin
    if not contains({"_equal", "_unequal", "_less", "_leequal"}, type(rel)) then
      return(UNKNOWN)
    end_if;
    
    st:= property::isxRel(rel);
    ty:= type(rel);
    ret:= UNKNOWN;
    // !! jeden Fall !!
    if TRUE then
      // infinity
      if {-infinity, infinity} intersect {op(rel)} <> {}
         and contains({"_leequal", "_less"}, type(rel)) then
        if op(rel, 1) = infinity or op(rel, 2) = -infinity then
          return(FALSE)
        elif op(rel, 1) = -infinity or op(rel, 2) = infinity then
          return(TRUE)
        end_if
      end_if;

      if property::isxRel((rell:= subsop(rel, 1 = 0, // a + 1 > a
                                                 2 = op(rel, 2) - op(rel, 1)))) = 0
         and not has(rell, undefined) then
        if domtype(property::carefloat(op(rell, 1))) = DOM_COMPLEX
           or domtype(property::carefloat(op(rell, 2))) = DOM_COMPLEX then
          return(FALSE)
        else
          return(bool(rell))
        end_if
      elif nops(indets(rel)) + nops(indets(op(rel, 1))) + nops(indets(op(rel, 2)))
           > nops(indets(rell)) + nops(indets(op(rell, 1))) + nops(indets(op(rell, 2))) then
        //userinfo(Text, 9, "Simplify to ", rell);
        ret:= property::isrel(rell);
        if ret <> UNKNOWN then
          return(ret)
        end_if
      elif (ret:= contains([op(rel)], 0)) > 0 then
        if contains({"_plus", "_subtract"}, type(op(rel, 3 - ret))) then
          // a + b > 0 => b > -a
          rell:= op(rel, 3 - ret);
          if ret = 1 then
            ret:= property::isrel(op(rel, 0)(-rell + op(rell, 1), op(rell, 1)))
          else
            ret:= property::isrel(op(rel, 0)(op(rell, 1), -rell + op(rell, 1)))
          end_if;
          if ret <> UNKNOWN then return(ret) end_if
        end_if
      end_if
    end_if;
    //  0   1   2   3   4   5   6   7   8   9  10  11  12  13  14  15
    // t-t/i-t/e-t/p-t/t-i/i-i/e-i/p-i/t-e/i-e/e-e/p-e/t-p/i-p/e-p/p-p
    case st
      of i_t do // i-t
      of e_t do // e-t
        ret:= property::implies(property::_getprop(op(rel, 1)),
                               property::Rel(op(rel, 0), op(rel, 2)));
        if ret = UNKNOWN then
          if (rell:= property::Factor(op(rel, 1))) <> op(rel, 1) then
            ret:= property::implies(property::_getprop(rell),
                                   property::Rel(op(rel, 0), op(rel, 2)));
          end_if
        end_if;
        break
      of t_i do // t-i
      of t_e do // t-e
        ret:= property::implies(property::_getprop(op(rel, 2)), //wie 2, nur umgekehrt
                               property::Rel(-op(rel, 0), op(rel, 1)));
        //ret:= property::_is#prop#(#property::_getprop#(op(rel, 2)), // warum hier anders??
        //                     property::Rel(-op(rel, 0), op(rel, 1)));
        if ret = UNKNOWN then
          if (rell:= property::Factor(op(rel, 2))) <> op(rel, 2) then
            ret:= property::implies(property::_getprop(rell),
                                   property::Rel(-op(rel, 0), op(rel, 1)));
          end_if
        end_if;
        break
      of p_t do // p-t
      of p_i do // p-i
      of p_e do // p-e
        return(UNKNOWN);
        break
      of t_p do // t-p
      of i_p do // i-p
      of e_p do // e-p
        return(UNKNOWN);
        break
      of p_p do // p-p
        return(UNKNOWN);
        break
      //of 4 do // i-i
      //of 5 do
      //of 7 do
      //of 8 do
      otherwise
        ret:= property::implies(property::_getprop(op(rel, 2)),
                               property::Rel(-op(rel, 0), op(rel, 1)));
        if not(contains({TRUE, FALSE}, ret)) then
          //property::reset(0):
          ret:= property::implies(property::_getprop(op(rel, 1)),
                                 property::Rel(op(rel, 0), op(rel, 2)))
        end_if;
    end_case;
    if st <> 0 and ret = UNKNOWN then
      if contains({"_equal", "_unequal"}, ty) then // _equal, _unequal
        if testtype(op(rel, 1), Type::Constant) then
          if testtype(op(rel, 2), Type::Constant) then
            if hastype(rel, DOM_COMPLEX) then
// !!!!!!!!!!!!!!!!!!!!!!!!! COMPLEX !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
              ret:= UNKNOWN
            elif hastype(rel, DOM_IDENT) then
              ret:= bool(map(rel, float))
            else
              ret:= bool(rel)
            end_if
          else
            st:= property::isreleq(type(rel), op(rel, 2) - op(rel, 1));
            if st <> UNKNOWN then
              ret:= st
            end_if
          end_if
        elif testtype(op(rel, 2), Type::Constant) then
          st:= property::isreleq(type(rel), op(rel, 1) - op(rel, 2));
          if st <> UNKNOWN then
            ret:= st
          end_if
        else
          //ret:= property::is_equal(op(rel));
          if ret = UNKNOWN then
            ret:= property::implies(property::_getprop(op(rel, 1)),
                                   property::Rel(-hold(_leequal), op(rel, 2)));
            if ret = TRUE then
              ret:= property::implies(property::_getprop(op(rel, 1)),
                                     property::Rel(hold(_leequal), op(rel, 2)));
            end_if
          end_if
        end_if
      end_if
    end_if;
    
//     // ! u. U. falsch
//     if map(indets(rel), property::_getprop)
//        intersect {Type::Complex, Type::Imaginary, Type::IntImaginary} <> {}
//        and contains({"_less", "_leequal"}, type(rel)) then
//       return(FALSE)
//     elif map(indets(rel), type) intersect {"Complex"} <> {} 
//        and contains({"_less", "_leequal"}, type(rel)) then
//       return(FALSE)
//     end_if;

    ret
  end_proc:

unalias(t_t):unalias(i_t):unalias(e_t):unalias(p_t):unalias(t_i):unalias(i_i):
unalias(e_i):unalias(p_i):unalias(t_e):unalias(i_e):unalias(e_e):unalias(p_e):
unalias(t_p):unalias(i_p):unalias(e_p):unalias(p_p):

property::Factor:=
  proc(EXPR)
    local RET;
  begin
    //return(EXPR);
    if not contains({"_plus", "_mult"}, type(EXPR)) then
      return(EXPR)
    end_if;
    // RET:= Factor(EXPR);
    if traperror((RET:= maprat(EXPR, x->Factored::convert_to(factor(x),DOM_EXPR)))) <> 0 then
      return(EXPR)
    end_if;
    if RET <> EXPR then
      return(RET)
    end_if;
    RET:= split(EXPR, hastype, DOM_IDENT);
    // RET:= op(EXPR, 0)(Factor(op(RET, 1)), op(RET, 2))
    // factorize terms with idents
    RET:= op(EXPR, 0)(maprat(op(RET, 1), x->Factored::convert_to(factor(x),DOM_EXPR)), op(RET, 2))
  end_proc:

// Bewertung einer Relation 
property::isxRel:=
  proc(rel)
  begin
    //  0   1   2   3   4   5   6   7   8   9  10  11  12  13  14  15
    // t-t/i-t/e-t/p-t/t-i/i-i/e-i/p-i/t-e/i-e/e-e/p-e/t-p/i-p/e-p/p-p
    contains([DOM_IDENT, DOM_EXPR, Type], domtype(op(rel, 1))) +
    contains([0, 0, 0, DOM_IDENT, 0, 0, 0, DOM_EXPR, 0, 0, 0, Type], domtype(op(rel, 2)))
  end_proc:

// Bewertung OP =|<> 0
// TYPE in {"_equal", "_unequal"}, OP rel(TYPE) 0
property::isreleq:=
  proc(TYPE, OP)
  begin
    if iszero(OP) then
      bool(TYPE = "_equal")
    elif type(OP) = "_power" and testtype(op(OP, 2), Type::NegInt)
         and type(op(OP, 1)) = DOM_IDENT then
      bool(TYPE = "_unequal")
    elif type(OP) = "_mult"
         and type(op(OP, 1)) = "_power" and testtype(op(OP, [1, 2]), Type::NegInt)
         and type(op(OP, [1, 1])) = DOM_IDENT then
      bool(_if(TYPE = "_equal", id, _not)(property::isrel(subsop(OP, 1 = 1) = 0)))
    else
      UNKNOWN
    end_if;
  end_proc:

// property::is_equal:=
//   proc(ex1, ex2)
//   begin
//     if bool(ex1 = ex2) then
//       return(TRUE)
//     elif type(ex1) = type(ex2) and nops(ex1) = nops(ex2) then
//       _and(property::isrel(op(ex1, i) = op(ex2, i)) $ i = 1..nops(ex1))
//     else
//       UNKNOWN
//     end_if
//   end_proc:

property::rel:=
  proc(Rel, Ind = null())
    local k;
  begin
    if Ind <> null() then
      if (k:= contains([op(Rel)], Ind)) > 0 then
        return(property::Rel(_if(k = 1, 1, -1)*op(Rel, 0), op(Rel, 3 - k)))
      else
        Type::Real
      end_if
    else
      Ind:= indets(Rel);
      if nops(Ind) = 1 then
        property::rel(Rel, op(Ind))
      else
        hold(_and)(property::Rel(op(Rel, 0), op(Rel, 2)), property::Rel(-op(Rel, 0), op(Rel, 1)))
      end_if
    end_if
  end_proc:

property::isrel:=
  prog::remember(property::isrel, property::depends, hold(PreventRecursion), UNKNOWN):
