/*++
fact -- factorial function

fact(n)

n - expression
++*/

fact:=
proc(x)
  option noDebug;
begin
  if args(0) = 0 then
    error("no arguments given")
  elif x::dom::fact <> FAIL then
    x::dom::fact(args())
  elif args(0) <> 1 then
    error("expecting one argument")
  end_if;

  case type(x)
    of DOM_SET do
    of "_union" do
      return(map(x, fact))
  end_case;
  
  if not testtype(x,Type::Arithmetical) then
    error("argument must be of 'Type::Arithmetical'")
  else
    specfunc::fact(args())
  end_if
end_proc:

fact:= funcenv(fact):
fact:= slot(fact, "print", "fact"):
fact:= slot(fact, "info", "fact -- the factorial function"):
fact:= slot(fact, "type", "fact"):

fact:= slot(fact,"expand",
    loadproc(slot(fact,"expand"),pathname("STDLIB","EXPAND"),"fact")
):

fact:= slot(fact, "series", proc(x) begin
    slot(gamma,"series")(x+1,args(2..args(0)))
end_proc):

// end of file 
