// PARI's round is ok, but we still need an interface function
// to handle sets ;-(

round := proc(a)
  option noDebug;
  save DIGITS;
begin
  if args(0) <> 1 then
    error("one argument expected")
  elif a::dom::round <> FAIL then
    return(a::dom::round(args()))
  end_if;

  case type(a)
    of DOM_INT do return(a);
    of DOM_RAT do
    of DOM_FLOAT do
    of DOM_COMPLEX do
       return(specfunc::round(a));
    of DOM_SET do
    of "_union" do
       return(map(a, round))
  end_case;
  
  if not testtype(a,Type::Arithmetical) then
     error("argument must be of 'Type::Arithmetical'")
  end_if;

  specfunc::round(a):
end_proc:

round:= funcenv(round):
round:= slot(round, "float", specfunc::round):

round:= slot(round, "undefined", {}):
round:= slot(round, "realDiscont", Dom::ImageSet(hold(n)+1/2, hold(n), Z_)):

round:= slot(round,"series",
	loadproc(slot(round,"series"),pathname("SERIES"),"round")):


