sec :=
proc(x)
    option noDebug;
    // sec(x) = 1/cos(x) 
begin
  if args(0) = 0 then
    error("no arguments given")
  elif x::dom::sec <> FAIL then
    return(x::dom::sec(args()))
  elif args(0) <> 1 then
    error("1 argument expected")
  end_if;

  case type(x)
    of DOM_SET do
    of "_union" do  
      return(map(x, sec))  
  end_case;
      
  
  if not testtype(x,Type::Arithmetical) then
    error("argument must be of 'Type::Arithmetical'")
  end_if;
    
  x:= cos(x);
  if iszero(x) then
    error("singularity")
  else
    1/x
  end_if;
end_proc:

sec := funcenv(sec):
sec := slot(sec, "type", "sec"):
sec := slot(sec, "print", "sec"):
sec := slot(sec, "info", "sec -- the secant"):

sec := slot(sec, "inverse", "arcsec"):

sec := slot(sec, "expand", proc() begin expand(1/cos(args(1))) end_proc  ):

sec := slot(sec, "conjugate",
    loadproc(slot(sec,"conjugate"),pathname("STDLIB","CONJ"),"sec")
):

// end of file 
