// $Date: 2000/05/21 15:04:15 $ $Author: bij $ $Revision: 1.3 $ 

/*--
	gamma/expand -- the function attribut "expand" for gamma
--*/

gamma:= slot( gamma, "expand",
proc(e) local i,j;
begin
   if type(e)="_plus" then
      i:=op(e,nops(e)); // integers are always in the last operand ??? 
      if testtype(i,Type::PosInt) then
         return(_mult(gamma(e-i),e-j$j=1..i))
      elif testtype(i,Type::NegInt) then
         _mult(e+j$j=0..-i-1);
         return(gamma(e-i)/%)
      end_if
   end_if;
   gamma(e)
end_proc):

// end of file 
