// $Date: 2000/05/21 15:04:22 $ $Author: bij $ $Revision: 1.4 $ 

/*--
	sin/Im -- the function attribut "Im" for sin
--*/

sin := slot( sin, "Im", proc(x)
        local r, s;
    begin
        r := Re(x);
        if r = x then 
            return( 0 )
        elif not has(r,{hold(Re),hold(Im)}) then
            s := Im(x);
            if not has(s,{hold(Re),hold(Im)}) then
                return( cos(r)*sinh(s) )
            end_if
        end_if;
        return( FAIL )
    end_proc
):

// end of file 
