// $Date: 2000/05/21 15:04:22 $ $Author: bij $ $Revision: 1.4 $ 

/*--
	tanh/Im -- the function attribut "Im" for tanh
--*/

tanh := slot( tanh, "Im", proc(x)
        local r, s;
    begin
        r := Re(x);
        if r = x then 
            return( 0 )
        elif not has(r,{hold(Re),hold(Im)}) then
            s := Im(x);
            if not has(s,{hold(Re),hold(Im)}) then
                return( sin(s)*cos(s)/(sinh(r)^2+cos(s)^2) )
            end_if
        end_if;
        return( FAIL )
    end_proc
):

// end of file 
