// $Date: 2000/05/21 15:04:25 $ $Author: bij $ $Revision: 1.4 $ 

/*--
	cos/Re -- the function attribut "Re" for cos
--*/

cos := slot( cos, "Re", proc(x)
        local r, s;
    begin
        r := Re(x);
        if r = x then 
            return( cos(x) )
        elif not has(r,{hold(Re),hold(Im)}) then
            s := Im(x);
            if not has(s,{hold(Re),hold(Im)}) then
                return( cos(r)*cosh(s) )
            end_if
        end_if;
        return( FAIL )
    end_proc
):

// end of file 
