// $Date: 2000/05/21 15:04:25 $ $Author: bij $ $Revision: 1.4 $ 

/*--
	cot/Re -- the function attribut "Re" for cot
--*/

cot := slot( cot, "Re", proc(x)
        local r, s;
    begin
        r := Re(x);
        if r = x then 
            return( cot(x) )
        elif not has(r,{hold(Re),hold(Im)}) then
            s := Im(x);
            if not has(s,{hold(Re),hold(Im)}) then
                return( sin(r)*cos(r) / (sin(r)^2+sinh(s)^2) )
            end_if
        end_if;
        return( FAIL )
    end_proc
):

// end of file 
