// $Date: 2000/05/21 15:04:27 $ $Author: bij $ $Revision: 1.4 $ 

/*--
	tanh/Re -- the function attribut "Re" for tanh
--*/

tanh := slot( tanh, "Re", proc(x)
        local r, s;
    begin
        r := Re(x);
        if r = x then 
            return( tanh(x) )
        elif not has(r,{hold(Re),hold(Im)}) then
            s := Im(x);
            if not has(s,{hold(Re),hold(Im)}) then
                return( sinh(r)*cosh(r)/(sinh(r)^2+cos(s)^2) )
            end_if
        end_if;
        return( FAIL )
    end_proc
):

// end of file 
