// $Date: 2000/06/16 07:34:50 $  $Author: tonner $  $Revision: 1.3 $

/*
        iquo(b,a) liefert den ganzzahligen Quotienten bei Division b durch a.
*/
iquo:= proc(b,a)
begin
    if args(0) <> 2 then
        error("expecting two arguments")
    end_if;
    if domtype(b) = DOM_INT then
        if domtype(a) = DOM_INT then
            return( specfunc::trunc(b/a) )
        elif testtype( a,Type::Numeric ) then
            error("Integer expected")
        else
            return( procname(b,a) )
        end_if
    elif testtype( b,Type::Numeric ) or domtype(a) <> DOM_INT and testtype(a,Type::Numeric) then
        error("Integer expected")
    else
        return( procname(b,a) )
    end_if
end_proc:

