// mainly used for the reversion of Puiseux series 

revert := proc(x)
begin
   if x::dom::revert<>FAIL then return(x::dom::revert(x)) end_if;
   procname(args())
end_proc:

// to revert strings, code from Ralf Hillebrand, 31 Oct 1996 
DOM_STRING::revert :=
  proc(str)
    local len, i;
  begin
    len := length(str);
    _concat(str[len-i] $ i = 1..len)
  end_proc:

// to revert lists, code from Ralf Hillebrand, 17 Feb 1997 
DOM_LIST::revert := 
  proc(list)
    local len, i;
  begin
    len := nops(list) + 1;
    [op(list, len-i) $ i=1..len-1]
  end_proc:
