stringlib::pos := proc(s, t, r)
   local a, b, m, n;
begin

   if testargs() then

      if not (testtype(s, DOM_STRING) and s <> "" and
              testtype(t, DOM_STRING) and t <> "") then
         error("Non-empty string expected")
      end_if;
      m := length(s); n := length(t);
      if args(0) = 2 then
         a := 0
      elif type(r) = "_range" then
         a := op(r, 1); b := op(r, 2);
         if not (testtype(a, Type::NonNegInt) and testtype(b, Type::NonNegInt))
            or b < a or b >= m then
            error("Illegal range")
         else
            m := b
         end_if
      elif not testtype(r, Type::NonNegInt) or r >= m then
         error("Illegal index")
      else
         a := r
      end_if

   else

      n := length(t);
      if args(0) = 2 then
         a := 0; m := length(s);
      elif type(r) = "_range" then
         a := op(r, 1); m := op(r, 2);
      else
         a := r; m := length(s);
      end_if

   end_if;
      
   stringlib::match(s, t, m, n, a)

end_proc:
