// $Date: 2000/11/28 11:36:27 $  $Author: bij $  $Revision: 1.5 $

//Residue Class -- expression to test for residue class

Type::Residue:=
  proc(RM = 0 : DOM_INT, CL = 0 : DOM_INT, ST = Type::Integer)
    local rs;
  begin
    rs:= property::Residue(RM, CL, ST);
    if type(rs) = "Residue" then
      new(property::Residue,
          "Residue",
          proc(t,x)
            option noDebug;
          begin
            if args(0) <> 2 then return(FALSE) end_if;
            if domtype(x) = DOM_INT then
              bool((x mod op(t, 2)) = op(t, 1))
              and testtype(x, op(t, 3))
            else
              FALSE
            end_if
          end_proc,
          [rs::dom::remainder(rs), rs::dom::modulus(rs), rs::dom::range(rs)], FALSE,
          [rs::dom::remainder(rs), rs::dom::modulus(rs), rs::dom::range(rs)])
    else
      rs
    end_if
  end_proc:
