/*
 * File:         MGR_init.h
 *
 * Inhalt:       Diese Datei enth"alt die Deklarationen der Funktionen
 *               MGR_init() und MGR_exit(), welche in MGR_init.c definiert
 *               sind. Diese waren zuvor in MGR_sys_func.c vereinbart.
 *
 * Autor:        Gudrun Oevel, Thorsten Schulze
 *
 * Datum:        27.09.1994
 */

#ifndef __MGR_init__
#define __MGR_init__

extern const char *const MGRC_XMAX;
extern const char *const MGRC_YMAX;
extern const char *const MGRC_ZMAX;
extern const char *const MGRC_XMIN;
extern const char *const MGRC_YMIN;
extern const char *const MGRC_ZMIN;

/*
 * Funktionen
 */
void      MGR_init();
void      MGR_exit();

#endif /* __MGR_init__ */
