/* $Date: 1999/09/02 15:39:39 $  $Author: kg $  $Revision: 1.7 $ */

/**************************************************************************/
/* FILE:             MHI_history.h                                        */
/* Autor:            Oliver Kluge                                         */
/* Erstellt:         17/07/91                                             */
/* Letzte Aenderung: 10/09/93                                             */
/**************************************************************************/

#ifndef __MHI_history__
#define __MHI_history__

#define MHIC_HISTORY_DEFAULT 20


void MHI_init(  );
void MHI_exit(  );
void MHI_reset(  );

S_Pointer MHI_new_client_context();
void MHI_delete_client_context(S_Pointer ctx);
void MHI_activate_client_context(S_Pointer ctx, bool activate);

void MHI_insert_history(S_Pointer cmd, S_Pointer res);
void MHI_change_HISTORY(long h);
long MHI_get_HISTORY();
S_Pointer MHI_get_last(long i);
S_Pointer MHI_get_history(long i);
long MHI_get_history_index();


inline void MHI_write(S_Pointer value) {
    if (MEVV_ACT_ENV != MMMNULL) {
	MPE_env_set_history(MEVV_ACT_ENV, value);
    }
}

#endif /* __MHI_history__ */
