/* $Date: 1999/06/02 07:22:27 $  $Author: kg $  $Revision: 1.9 $ */

/**************************************************************************/
/* FILE:             MTA_table.h                                          */
/* Autor:            Andreas Kemper                                       */
/* Erstellt:         07/11/91                                             */
/* Letzte Aenderung: 02/06/93                                             */
/**************************************************************************/

#ifndef __MTA_table__
#define __MTA_table__

#include "MID_ident.h"

/* Zur Steuerung des Lesen/Schreiben von Tabelleneintraegen *************/

#define MTAC_ARG      0
#define MTAC_FUNC     1
#define MTAC_INDEX    2
#define MTAC_LIST     3


S_Pointer MTA_eval_table_call(	S_Pointer	 s,
				long		 prev_func,
				long		 eval_type,
				S_Pointer	 exec );
S_Pointer MTA_new_table ( );
long      MTA_read_table (	S_Pointer	 table,
				S_Pointer	 args,
				long		 ignore,
				S_Pointer	*result );
void      MTA_write_table (	S_Pointer	*table,
				S_Pointer	 args,
				long		 ignore,
				S_Pointer	 value,
				short            force=MIDC_option_standard|MIDC_option_delete);
bool      MTA_get_name (	S_Pointer	 table,
				S_Pointer	*name );
void      MTA_set_name (	S_Pointer	 table,
				S_Pointer	 name );

#endif /* __MTA_table__ */
