// Zum testen     
// Minimalklasse die auf einen Filedescriptor schreibt          
                 
#include <stdio.h>
#include "MKT_stream.h"  

class mystream : public MTstream
{                
private:         
   FILE *fp_ ;       
   static const char *text_ ;

public:     
   mystream( FILE* str ) ; 
   ~mystream() ;
         
   // Lese Bytes vom Stream in den Puffer buff
   Stat read(void* buff, size_t buff_len, size_t& num_read) ;
   // Schreibe Bytes auf den Stream, lese diese aus data
   Stat write(const void* data, size_t num_bytes, size_t& num_written) ;
   // Puffer ggf. leeren...
   Stat flush() ;
   // End Of Media erreicht?
   bool eom() const ;
   // Hinweis auf die Groesse des Streams (fuer die Ausgabe).
   // Kann vom Sttream ggf. ignoriert werden.
   Stat set_size(size_t size) ;
   // Status des Streams.
   Stat status() ;      
   // Liefert Text zum aktuellen Status (fuer Fehlermeldungen).
   const char* status_text() ;

protected:
   Stat status(Stat);
} ;      
