alias(Heap = atd::Heap):
alias(Heap_node = (adt::Heap)::Heap_node):

    Heap_node::_less   	:= 	proc(i,j)
				begin
				  return(bool(op(i,1)<op(j,1)))
				end_proc:

    Heap_node::new	:=	proc(value,cont)
				begin
				  return(new(Heap_node,value,cont)):	
				end_proc:

    Heap_node::value	:=	proc(H)
				begin
				  return(extop(H,1))
				end_proc:

    Heap_node::content	:=	proc(H)
				begin
				  return(extop(H,2))
				end_proc:

    Heap_node::print	:=	proc(H)
				begin
				  [extop(H,1),extop(H,2)]
				end_proc:

    Heap_node::_leequal	:=	proc(N,i)
				begin
				  if extop(N,0) = (adt::Heap)::Heap_node then return(bool(extop(N,1)<=extop(i,1))) end_if:
				  return(bool(N<=extop(i,1)))
				end_proc:

    Heap_node::dispose	:=	proc(i)
				begin
				  return(new(Heap_node,extop(i,1),""))
				end_proc:

unalias(Heap_node):
unalias(Heap):
