
// Endliches Kartesisches Produkt endlicher Mengen. 

// n-Tupel werden als Listen realisiert. Dadurch    
// ist diese Operation leider nicht assoziativ:     
/* cartesian( {1,2} , cartesian( {a,b} , {x,y} ) )
 = { [1,[a,x]] , [1,[a,y]] , [1,[b,x]] , [1,[b,y]] ,
     [2,[a,x]] , [2,[a,y]] , [2,[b,x]] , [2,[b,y]] }
<> { [[1,a],x] , [[1,a],y] , [[1,b],x] , [[1,b],y] ,
     [[2,a],x] , [[2,a],y] , [[2,b],x] , [[2,b],y] }
 = cartesian( cartesian( {1,2} , {a,b} ) , {x,y} ) */

// Statt einer Menge kann auch eine natuerliche     
// Zahl N uebergegeben werden, die dann wie die     
// Menge {1,..,N} behandelt wird.                   

combinat::cartesian:=proc()
    local i,F,c;
begin
    if contains(map({args()},type),DOM_INT) then
      map([args()],proc() begin (
	if type(args(1))=DOM_INT then
	  if args(1) < 0 
	    then error("argument(s) must be set(s) or non-negative integer(s)") 
	  end_if; 
	  {$1..args(1)}
	else
	  if type(args(1)) <> DOM_SET then
	     error("argument(s) must be set(s) or non-negative integer(s)") ;
	  else
	     args(1) ;
	  end_if ;
	end_if ) end_proc );
      return(combinat::cartesian(op(%)))
    end_if;
    if testargs() then
      if not _and(op(map({args()},proc() begin type(args(1))=DOM_SET end_proc )))
	then error("argument(s) must be set(s) or non-negative integer(s)") 
      end_if
    end_if;
    case args(0)
      of 0 do error("wrong no of args")
      of 1 do return(map(args(1), DOM_LIST))
      of 2 do  // Spezialbeschleunigte Routine fuer n=2: 
        return(map(args(2), proc() begin op(map(args(2), DOM_LIST, args(1))) end_proc , [op(args(1))]))
      otherwise
        F:=proc() begin [op(args(1)),args(2)] end_proc ;
        c:= map(args(1),DOM_LIST);
        for i from 2 to args(0) do
          c:= map(args(i),proc() begin op(map(args(2),F,args(1))) end_proc ,c)
        end_for
    end_case
end_proc:

