// $Date: 2000/05/21 14:53:07 $ $Author: bij $ $Revision: 1.4 $ 
/*++
Ax::cancellation -- the cancellation law for a commutative operation

The cancellation law states that for a commutative operation op
op(a,b) = op(a,c) implies b = c.

Ax::cancellation(o)

o - the name of the operation (string)
++*/

axiom Ax::cancellation(oper: DOM_STRING)
begin
    if args(0) <> 1 then error("wrong no of args") end_if
end_axiom:

