// $Date: 2000/05/21 14:53:08 $ $Author: bij $ $Revision: 1.3 $ 
/*++
Ax::distributive -- the axiom that two operations are Ax::distributive

Ax::distributive(o1, o2)

o1,o2 - names of the operations (string)

The axiom states that o1(x,o2(y,z)) = o2(o1(x,y),o1(x,z)) and
o1(o2(x,y),z) = o2(o1(x,z),o1(y,z)) for all x,y,z.
++*/

axiom Ax::cancellation(op1: DOM_STRING, op2: DOM_STRING)
begin
    if args(0) <> 2 then error("wrong no of args") end_if;
    if op1 = op2 then error("operators are equal") end_if
end_axiom:

