// $Date: 2000/05/21 14:53:14 $ $Author: bij $ $Revision: 1.5 $ 
/*++
Cat::EntireRing -- the category of rings

An Cat::EntireRing is a Cat::Ring with no zero divisors, ie. a <> 0 and b <> 0
implies a*b <> 0.
++*/

category Cat::EntireRing
  category Cat::Ring, Cat::RightModule(dom);
  axiom Ax::noZeroDivisors;
  
begin

end_category:
