// $Date: 2000/05/21 14:53:29 $ $Author: bij $ $Revision: 1.5 $ 

/*++
printInfo -- print information about constructor

printInfo(AC)

AC - axiom constructor

printInfo prints some information about AC onto the screen.
++*/

AxiomConstructor::printInfo:= proc(AC: AxiomConstructor): DOM_NULL
    option noDebug;
    local p;
    save  PRETTYPRINT;
begin
    PRETTYPRINT:= FALSE;
    p:= proc() begin print(Unquoted, args()) end_proc;
    AC:= extop(AC,1);
    p("-- Axiom Constructor:");
    p(op(AC, 6));
    p("");
    if op(AC,1) = NIL then
	p("-- No Parameters.");
    else
	p("-- Formal Parameters:");
	p(op(AC,1))
    end_if;
    null()
end_proc:

// end of file 
