// $Date: 2000/05/21 14:53:37 $ $Author: bij $ $Revision: 1.5 $ 

/*++
whichEntry -- returns the domain or category defining an entry

whichEntry(Dom, e)

Dom - domain
e   - name of entry

Uses makeEntry to find the definition of the entry. The defining
domain or category is stored in the second element of the returned list.

The entry is also created, which is neseccary anyway to check if
the definition returns FAIL or 'toBeDefined'.
++*/

DomainConstructor::whichEntry:= proc(DOM: DOM_DOMAIN, e: DOM_STRING)
    option noDebug;
begin
    DomainConstructor::makeEntry(DOM, e)[2]
end_proc:

// end of file 
