combinat:=newDomain("combinat"):
combinat::info:="Library 'combinat': combinatorial functions":

combinat::interface:={hold(bell), hold(partitions), hold(permute), 
                      hold(powerset), hold(stirling1), hold(stirling2),
                      hold(modStirling),
		      hold(cartesian), hold(composition), hold(choose) }:

alias(path = pathname("COMBINAT")):

combinat::permute:= loadproc(combinat::permute, path, "permute"):
combinat::powerset:= loadproc(combinat::powerset, path, "powerset"):
combinat::modStirling:= loadproc(combinat::modStirling, path, "modstirl"):
combinat::stirling1:= loadproc(combinat::stirling1, path, "stirl1"):
combinat::stirling2:= loadproc(combinat::stirling2, path, "stirl2"):
combinat::partitions:= loadproc(combinat::partitions, path, "parts"):
combinat::bell:= loadproc(combinat::bell, path, "bell"):
combinat::cartesian:= loadproc(combinat::cartesian, path, "cartes"):
combinat::composition:= loadproc(combinat::composition, path, "composit"):
combinat::choose:= loadproc(combinat::choose, path, "choose"):

stdlib::LoadlibState["combinat"]:= TRUE:

null():

