// $Date: 2000/05/21 14:55:10 $ $Author: bij $ $Revision: 1.11 $ 
/*++
domains -- a library for constructing domains and categories
++*/

domains:= newDomain("domains"):
domains::info:= "Library 'domains': constructing domains and categories":
domains::interface:= { hold(hasProp) }:

alias(path = pathname("DOMAINS", "CONSTR"));
domains::hasProp:= loadproc(domains::hasProp, path, "DChasPro"):

unalias(path):
alias(path = pathname("DOMAINS", "CATEGORY"));
domains::discreteLog:=loadproc(domains::discreteLog, path, "discrlog"):
domains::grouporder:= loadproc(domains::grouporder, path, "grorder"):
domains::repeatedSquaring:= loadproc(domains::repeatedSquaring, path, "rep_sq"):

stdlib::LoadlibState["domains"]:= TRUE:

// end of file 
