// $Date: 2000/05/21 14:55:10 $ $Author: bij $ $Revision: 1.9 $ 
// kg, 19/09/95 

/*++
fp -- a library of functional programming utilities
++*/

fp:= newDomain("fp"):
fp::info:= "Library 'fp': utilities for functional programming":
fp::interface:= {
    hold(bottom),
    hold(apply),
    hold(nest),
    hold(nestvals),
    hold(fold),
    hold(curry),
    hold(fixargs),
    hold(fixedpt),
    hold(unapply),
    hold(expr_unapply)
}:

// fp::bottom -- the bottom function which never returns 
fp::bottom:= proc() begin error("bottom reached") end_proc:

alias(path = pathname("FP")):

fp::apply:= loadproc(fp::apply, path, "apply"):
fp::nest:= loadproc(fp::nest, path, "nest"):
fp::nestvals:= loadproc(fp::nestvals, path, "nestvals"):
fp::fold:= loadproc(fp::fold, path, "fold"):
fp::curry:= loadproc(fp::curry, path, "curry"):
fp::fixargs:= loadproc(fp::fixargs, path, "fixargs"):
fp::fixedpt:= loadproc(fp::fixedpt, path, "fixedpt"):
fp::unapply:= loadproc(fp::unapply, path, "unapply"):
fp::expr_unapply:= loadproc(fp::expr_unapply, path, "eunapply"):

stdlib::LoadlibState["fp"]:= TRUE:

null():

// end of file 
