// $Date: 2000/09/22 08:48:12 $ $Author: tonner $ $Revision: 1.31 $

// kg, 13/12/94

//
// prog.mu -- define/load auxiliary functions
//

prog:= newDomain("prog"):

prog::info:= "Library 'prog': programming utilities":
prog::interface:=
   {hold(check),
    hold(changes),
    hold(init),
    hold(testinit),
    hold(testfunc),
    hold(test),
    hold(makeBinLib),
    hold(trace),
    hold(traced),
    hold(untrace),
    hold(profile),
    hold(memuse),
    hold(calltree),
    hold(exprtree),
    hold(allFunctions),
    //hold(allDomainMethods),
    hold(error),
    //hold(remember),
    hold(find),
    //hold(findSlot),
    hold(getname)
    }:

alias(path = pathname("PROG")):

// intern for prog::check
prog::globalIdents:= table():
prog::PATH:= []:

prog::check:= loadproc(prog::check, path, "check"):
prog::init := loadproc(prog::init , path, "checkini"):
prog::Entries:= loadproc(prog::Entries , path, "checkini"):
prog::isGlobal:= loadproc(prog::isGlobal, path, "checkini"):
prog::getname:= loadproc(prog::getname , path, "checknm"):
prog::VNM:= loadproc(prog::VNM , path, "check"):
prog::setcheckglobals:= loadproc(prog::setcheckglobals, path, "checkset"):
prog::getcheckglobals:= loadproc(prog::getcheckglobals, path, "checkset"):
prog::testinit:= loadproc(prog::testinit, path, "test"):
prog::testfunc:= loadproc(prog::testfunc, path, "test"):
prog::test:= loadproc(prog::test, path, "test"):
prog::makeBinLib:= loadproc(prog::makeBinLib, path, "makelib"):
prog::tcov:= loadproc(prog::tcov, path, "tcov"):
prog::trace:= loadproc(prog::trace, path, "trace"):
prog::traced:= loadproc(prog::traced, path, "trace"):
prog::untrace:= loadproc(prog::untrace, path, "trace"):
prog::checkexample:= loadproc(prog::checkexample, path, "checkexa"):
prog::profile:= loadproc(prog::profile, path, "profile"):
prog::memuse:= loadproc(prog::memuse, path, "memuse"):
prog::calltree:= loadproc(prog::calltree, path, "calltree"):
prog::exprtree:= loadproc(prog::exprtree, path, "exprtree"):
prog::allFunctions:= loadproc(prog::allFunctions, path, "allfunc"):
prog::allDomainMethods:= loadproc(prog::allDomainMethods, path, "allfunc"):

prog::error:= loadproc(prog::error, path, "error"):
prog::remember:= loadproc(prog::remember, path, "remember"):
prog::find:= loadproc(prog::find, path, "find"):
prog::findSlot:= loadproc(prog::findSlot, path, "findSlot"):

// compatibility
prog::Changes:= loadproc(prog::Changes, path, "compatible"):
prog::changes:= loadproc(prog::changes, path, "compatible"):

stdlib::LoadlibState["prog"]:= TRUE:

null():
