// frankp, 7/09/95

/*
    student -- the student package
*/

student:= newDomain("student"):
student::info:= "Library 'student': the student package":
student::interface:= {
    hold(isFree), hold(equateMatrix), hold(Kn),
    hold(simpson), hold(trapezoid), hold(riemann),
    hold(plotSimpson), hold(plotRiemann), hold(plotTrapezoid)
}:

alias(path = pathname("STUDENT")):

student::equateMatrix:= loadproc(student::equateMatrix,path, "equate"):
student::Kn          := loadproc(student::Kn,          path, "Kn"):
student::isFree      := loadproc(student::isFree,      path, "isFree"):
student::simpson     := loadproc(student::simpson,     path, "simpson"):
student::trapezoid   := loadproc(student::trapezoid,   path, "trapezoid"):
student::riemann     := loadproc(student::riemann,     path, "riemann"):
student::plotSimpson     := loadproc(student::plotSimpson,     path, "pl_simps"):
student::plotTrapezoid   := loadproc(student::plotTrapezoid,   path, "pl_trapez"):
student::plotRiemann     := loadproc(student::plotRiemann,     path, "pl_rieman"):

stdlib::LoadlibState["student"]:= TRUE:
null():

