// Trans.mu  --  library for transformations

transform:= newDomain("transform"):
transform::info := "Library 'transform': library for integral transformations":
transform::interface := { hold(laplace),hold(invlaplace),
                          hold(fourier),hold(invfourier)
			  // hold(mellin) // raus, da mellin nicht funktioniert
		       }:

alias(path = pathname("TRANS"));

transform::IntTrans:= loadproc( transform::IntTrans, path, "IntTrans" ):

unalias(path):

alias(path = pathname("TRANS","LAPLACE")):

transform::laplace:= loadproc( transform::laplace, path, "laplace" ):
transform::invlaplace:= loadproc( transform::invlaplace, path, "ilaplace" ):

unalias(path):

//alias(path = pathname("TRANS","FOURIER")):
// use Paul's version from STDLIB until Dirk has fixed/written it. 
alias(path = pathname("TRANS")):

transform::fourier:= loadproc( transform::fourier, path, "fourier" ):
transform::invfourier:= loadproc( transform::invfourier, path, "ifourier" ):

transform::mellin:= loadproc( transform::mellin, path, "mellin" ):

unalias(path):

stdlib::LoadlibState["transform"]:= TRUE:
null():

