// $Date: 2000/05/21 14:55:40 $ $Author: bij $ $Revision: 1.4 $ 
// sello, 12.6.97, siehe Diplomarbeit Meinolf Sellmann 1997  

/*++
delrow.mu -- delete row k
++*/

alias(Heap=adt::Heap):
alias(Tableau = linopt::Tableau):

Tableau::delrow		:=	proc(oldtbl,m,n,k)

/* Eingabe: Tableaukomponenten oldtbl,m,n und Zeilenindexliste k
  Ausgabe: Neue Tableaukomponente tbl
*/
				local newtbl,	// Ergebnistableaukomponente tbl	
				      K,	// Hilfsliste			
					i, l,j;
				begin
				  newtbl := array(1..m+2-nops(k),1..n+2):

				  K := [0,op(k,i)$ i=1..nops(k),m+3]:

				  newtbl := assignElements(newtbl,((([[i-l+2,j],oldtbl[i,j]])$ j=1..n+2)$ i=K[l-1]+1..K[l]-1)$ l=2..nops(K)):
								//(([[i,j],oldtbl[i+1,j]])$ j=1..n+2)$ i=k..m+1):
				  return(newtbl):
				 end_proc:


unalias(Tableau):
unalias(Heap):
