// $Date: 2000/05/21 14:55:42 $ $Author: bij $ $Revision: 1.2 $ 
// sello, 12.6.97, siehe Diplomarbeit Meinolf Sellmann 1997  

/*++
intfea.mu --  is tableau T feasible with respect to the integer constraints?
++*/

alias(Heap=adt::Heap):
alias(Tableau = linopt::Tableau):

Tableau::intfeasible	:=	proc(T)

/* Eingabe: Tableau T
  Ausgabe: boolscher Wert
*/
				local i,		// Laufvariable		
				      tbl,m,integer;	// Tableaukomponenten	

				begin
				  tbl := T[1]:
				  m := T[2]:
				  integer := T[12]:
				  for i from 3 to m+2 do
				    if integer[tbl[i,1]] and tbl[i,2] <> floor(tbl[i,2]) 
				      then return(FALSE)
				    end_if
				  end_for:
				  return(TRUE)  						  
				end_proc:
unalias(Tableau):
unalias(Heap):
