
stdlib::match:=
  proc(ex, pat, types = {}, Opt = null())
    local ret, co, opr, typ;
  begin
//    if type(ex) = "int" then
//      return(matchlib::int(op(ex)))
//    end_if;
    if type(ex) = DOM_SET then ex:= hold(DOM_SET)(op(ex)) end_if;
    if type(pat) = DOM_SET then pat:= hold(DOM_SET)(op(pat)) end_if;

    if types = hold(All) then
      Opt:= types;
      co:= {};
      opr:= {hold(_plus), hold(_mult)};
      typ:= {}
    else
      co:= {};
      opr:= {hold(_plus), hold(_mult)};
      typ:= {};
      if type(op(types)) = "_equal" then types:= {types} end_if;
      if types <> {} then
        map(op(types), X->if type(X) = "_equal" and type(op(X, 1)) = DOM_IDENT then
                            if op(X, 1) = op(X, 2) then
                              co:= co union {op(X, 1)}
                            else
                              typ:= typ union {X}
                            end_if
                          elif type(X) = DOM_IDENT then
                            co:= co union {X}
                          end)
      end_if
    end_if;
    
    ret:= matchlib::match(ex, pat, co, opr, typ, Opt);
    
    if not(contains({FAIL, {}}, ret)) then
      return(ret)
    end_if;
    if nops(ex) <> nops(pat) then
      matchlib::matchsub(ex, pat, co, opr, typ, Opt)
    else
      {}
    end_if
  end_proc:

match:= stdlib::match:

matchlib::match:=
  proc(ex, pt, co = {}, opr = {hold(_plus), hold(_mult)}, tp = {}, Opt = null())
  begin
    userinfo(Text, 1, "Try to match '", ex, "' to '", pt, "'");
    userinfo(Text, 2, "Parameters:  '", co, ", ", opr, ", ", tp, ", ", Opt);
    
    if co = hold(All) then co:= {}; Opt:= hold(All) end_if;
    ac_match(pt, ex, co, opr, tp, Opt)
  end_proc:



matchlib::matchsub:=
  proc(ex, pat, co, opr, typ, Opt = null())
  begin
    if nops(pat) < nops(ex) then
      matchlib::matchsub1(ex, pat, co, opr, typ, Opt)
    else
      matchlib::matchsub2(ex, pat, co, opr, typ, Opt)
    end_if
  end_proc:


// alle Kombinationen (lineare Ausdrucke!)
// nops(ex) > nops(pat)
matchlib::matchsub1:=
  proc(ex, pat, co, opr, typ, Opt = null())
    local i, subm, np, ne, m, sb, so, k, OP, ret;
  begin
    np:= nops(pat);
    ne:= nops(ex);
    if domtype(ex) = DOM_EXPR then
      OP:= op(ex, 0)
    else
      OP:= domtype(ex)
    end_if;
    if np = ne then return(matchlib::match(ex, pat, co, opr, typ, Opt)) end_if;
    subm:= combinat::choose(ne, np);
    ret:= {};
    for i from 1 to nops(subm) do
      sb:= op(subm, i); so:= {k $ k=1..ne} minus sb;
      if (m:= matchlib::match(eval(op(ex, 0)(op(ex, k) $ k in sb)), pat, co, opr, typ, Opt)) <> {} then
        if Opt = hold(All) then
          ret:= ret union {m union map({op(ex, k) $ k in so},
                                       x->(case OP
                                             of hold(_plus) do
                                               return(x = 0)
                                             of hold(_mult) do
                                               return(x = 1)
                                             of hold(DOM_SET) do
                                               return(FAIL)
                                             otherwise
                                               FAIL
                                           end_case))}
        else
          return(m union map({op(ex, k) $ k in so},
                             x->(case OP
                                   of hold(_plus) do
                                     return(x = 0)
                                   of hold(_mult) do
                                     return(x = 1)
                                   of hold(DOM_SET) do
                                     return(FAIL)
                                   otherwise
                                     FAIL
                                 end_case)))
        end_if
      end_if
    end_for;
    ret
  end_proc:

// alle Kombinationen (lineare Ausdrucke!)
// nops(pat) > nops(ex)
matchlib::matchsub2:=
proc(ex, pat, co, opr, typ, Opt = null())
    local i, subm, np, ne, m, sb, so, k, OP, ret;
  begin
    np:= nops(pat);
    ne:= nops(ex);
    if domtype(pat) = DOM_EXPR then
      OP:= op(pat, 0)
    else
      OP:= domtype(pat)
    end_if;
    if np = ne then return(matchlib::match(ex, pat, co, opr, typ, Opt)) end_if;
    subm:= combinat::choose(np, ne);
    ret:= {};
    for i from 1 to nops(subm) do
      sb:= op(subm, i); so:= {k $ k=1..ne} minus sb;
      if (m:= matchlib::match(ex, eval(op(pat, 0)(op(pat, k) $ k in sb)), co, opr, typ, Opt)) <> {} then
        if Opt = hold(All) then
        ret:= ret union {m union map({op(pat, k) $ k in so},
                                     x->(case OP
                                           of hold(_plus) do
                                             return(x = 0)
                                           of hold(_mult) do
                                             return(x = 1)
                                           of hold(DOM_SET) do
                                             return(x = hold(null()))
                                           otherwise
                                             x = FAIL
                                         end_case))}
        else
          return(m union map({op(pat, k) $ k in so},
                             x->(case OP
                                   of hold(_plus) do
                                     return(x = 0)
                                   of hold(_mult) do
                                     return(x = 1)
                                   of hold(DOM_SET) do
                                     return(x = hold(null()))
                                   otherwise
                                     x = FAIL
                                 end_case)))
        end_if
      end_if
    end_for;
  ret
  end_proc:

