/*-
 isEdge - checks whether an edge is contained in a Network
 isEdge(G,e)
 Parameters:
   G - Network
   e - edge
-*/
Network::isEdge := proc(G,e)
begin
   if testargs() then
      if args(0) <> 2 then
	error("Wrong number of arguments!"):
      end_if;
      Network::graph_check(G);
   end_if;
   if contains(Network::edge(G), e) <> 0 then
	TRUE
   else
	FALSE
   end_if;
end_proc:
