/*-
 isVertex - checks whether a vertex is contained in a Network
 isVertex(G,v)
 Parameters:
   G - Network
   v - vertex
-*/
Network::isVertex := proc(G,v)
begin
   if testargs() then
      if args(0) <> 2 then
	error("Wrong number of arguments!"):
      end_if;
      Network::graph_check(G);
   end_if;
   if contains(Network::vertex(G), v) <> 0 then
	TRUE
   else
	FALSE
   end_if;
end_proc:
