DOM_FUNC_ENV::Content := 
proc(Out:DOM_DOMAIN, data)
  local function, value;
begin
  if (function := data::print) <> FAIL then
    value := function(data);
    if domtype(value) = DOM_STRING then
      return(Out::Cci(text2expr(value)));
    else
      return(Out(value));
    end_if;
  else  // no 'print' function attribut => print the first operand 
    return(Out(op(data,1)));
  end_if
end_proc:

DOM_FUNC_ENV::Presentation := 
proc(Out:DOM_DOMAIN, data)
  local function, value;
begin
  if (function := data::print) <> FAIL then
    value := function(data);
    if type(value) = DOM_STRING then
      return(Out::mi(value));
    else
      return(Out(value));
    end_if;
  else  // no 'print' function attribut => print the first operand 
    return(Out(op(data,1)));
  end_if
end_proc:
