    //------------------------------------------------------------
    //                    b                                       
    //                    /                           /           
    // int(f, x=a..b) ->  | f d x  and int(f, x) ->   | f d x     
    //                    /                           /           
    //                    a                                       
    //------------------------------------------------------------
int::Presentation :=
proc(Out : DOM_DOMAIN, data)
begin
  if nops(data) <> 2 then
    return(Out::stdFunc(data));
  end_if;
  if type(op(data, 2)) = "_equal" then
    Out::mrow(
              Out::munderover(Out::mo("&Integral;"),
                              Out(op(data,[2,2,1])),
                              Out(op(data,[2,2,2]))),
              Out(op(data, 1)),
              Out::mo("&DifferentialD;"),
              Out(op(data,[2,1])))
  else
    Out::mrow(Out::mo("&Integral;"),
              Out(op(data, 1)),
              Out::mo("&DifferentialD;"),
              Out(op(data,2)))
  end_if;
end_proc:
    
