// $Date: 2000/05/21 14:57:38 $ $Author: bij $ $Revision: 1.3 $ 
// tonner, 23/06/98 

/*++
output::Indent -- Indentation of outputs
++*/


alias(mtype(d)  =extop(d,1)):
alias(entries(d)=op(d,2..extnops(d))):

// the only purpose of this domain is to represent linebreaks & indents
// for the output of formatted source
		    
domain output::Indent
  
  new := proc(str:DOM_STRING)
  begin
    if testargs() then
      if str <> "indent" and str <> "newline" then
	error("type \"indent\" or \"newline\" expected");
      end_if;
    end_if;
    new(dom, str, args(2..args(0)))
  end_proc;

  testtype  := FALSE;

  entries   := x -> entries(x);
  isIndent  := x -> bool( mtype(x)="indent" );
  isNewline := x -> bool( mtype(x)="newline" );

end_domain:

// end of file 
