output::operator :=
proc(str: DOM_STRING, p: DOM_PROC, otype: DOM_IDENT, prio: DOM_INT)
  local method;
begin
  case otype
    of Prefix do
      method := output::MathML::prefixOperator(str);
      break;
      
    of Postfix do
      method := output::MathML::postfixOperator(str);
      break;
      
    of Binary do
    of Nary do
      method := output::MathML::infixOperator(str);
      break;
      
    otherwise
      error("wrong type")
  end_case;

  context(subsop(hold(sysassign(NIL, NIL)),
		 1=op(p,6),
		 2=slot(funcenv(p), "mkOutput", method)));
end_proc:

