// $Date: 2000/05/21 14:57:39 $ $Author: bij $ $Revision: 1.3 $ 


/*

    output::ordinal(n)

    n - integer

    returns a string made of n and the proper suffix, e.g.
    output::ordinal(5)="5th", output::ordinal(21)="21st"

*/


output::ordinal:=
proc(n:DOM_INT)
begin
  case abs(n) mod 10
    of 1 do
      if abs(n) mod 100 <> 11 then
        return(expr2text(n)."st")
      else
        break
      end_if
    of 2 do
      if abs(n) mod 100 <> 12 then
        return(expr2text(n)."nd")
      else
        break
      end_if
    of 3 do
      if abs(n) mod 100 <> 13 then
        return(expr2text(n)."rd")
      else
        break
      end_if
  end_case;
  expr2text(n)."th"
end_proc:

