
Pref::timesDot:= funcenv(
    proc(v)
    begin
        case args(0) 
        of 0 do
            return( _pref(hold(TimesDot)) )
        of 1 do
            if args(1) = NIL then // set default value 
               v:= _pref(hold(TimesDot));
	       _pref(hold(TimesDot) = Pref::timesDot::default);
               return( v )
            elif not contains( {DOM_INT, DOM_STRING},domtype(v) ) then
               error("expecting integer or string")
            else
               _pref(hold(TimesDot));
	       _pref(hold(TimesDot) = v); 
               return( %2 )
            end_if
        otherwise
            error("wrong no of args (expecting integer or string)")
        end_case
    end_proc):

Pref::timesDot::info := "multiplication sign in PRETTYPRINT mode":
Pref::timesDot::default := " ":

// end of file 
