Pref::promptString:=
  funcenv
   (proc(s)
    begin
      case args(0) 
        of 0 do
          return(_pref(hold(PromptString)))
        of 1 do
          if args(1) = NIL then // set default value
            s:= _pref(hold(PromptString));
            _pref(hold(PromptString) = Pref::promptString::default);
            return(s)
          elif domtype(s) = DOM_STRING then
            if TEXTWIDTH - length(s) < 7 then
              error("'TEXTWIDTH' to small, minimal value 'length(promptString) + 7'")
            end_if;
            return(op([_pref(hold(PromptString)), _pref(hold(PromptString) = s)], 1))
          else
            error("expecting a string or NIL")
          end_if
      otherwise
    error("wrong no of args (expecting a string)")
    end_case
    end_proc):
Pref::promptString:= slot(Pref::promptString,
                          "info", "A character string to be displayed as a prompt."):

Pref::promptString:= slot(Pref::promptString, "default", ">> "):

// end of file 
