
Pref::warnLexProcEnv:= funcenv(
    proc(v)
    begin
        case args(0) 
        of 0 do
            return( _pref(hold(WarnLexProcEnv)) )
        of 1 do
            if args(1) = NIL then // set default value 
               v:= _pref(hold(WarnLexProcEnv));
	       _pref(hold(WarnLexProcEnv) = FALSE);
               return( v )
            elif not contains( {TRUE,FALSE},v ) then
               error("expecting TRUE or FALSE")
            else
               _pref(hold(WarnLexProcEnv));
	       _pref(hold(WarnLexProcEnv) = v);
               return( %2 )
            end_if
        otherwise
            error("wrong no of args (expecting TRUE or FALSE)")
        end_case
    end_proc):

Pref::warnLexProcEnv:= slot(Pref::warnLexProcEnv,
    "info","Warn about dead lexical closures found during garbage collection."):

Pref::warnLexProcEnv:= slot( Pref::warnLexProcEnv, "default", FALSE ):

// end of file 
