// $Date: 2000/10/04 08:28:21 $ $Author: kg $ $Revision: 1.4 $

//
// This file contains informations about changes
// between MuPAD 1.4.2 and MuPAD 2.0
//
// removed objects
// 

prog::Changes::removed:=
  table(
        [hold(Sysvar), hold(EVAL_STMT)] = [hold(Sysvar), FAIL, ""],
        [hold(Sysvar), hold(PRINTLEVEL)]= [hold(Sysvar), FAIL, ""],
        [hold(Sysvar), hold(ERRORLEVEL)]= [hold(Sysvar), FAIL, ""],
//        [hold(System), hold(sharelib)]  = [hold(System), FAIL, "library removed"],
    
        [hold(System), hold(fun)]       = [hold(System), fp::unapply, "use MuPAD procedures instead"],
        [hold(System), hold(func)]      = [hold(System), fp::unapply, "use MuPAD procedures instead"],
        [hold(System), hold(seq)]       = [hold(System), _seqgen, "use the '$'-operator instead"],
        [hold(System), "domain"]        = [hold(System), newDomain, "use 'newDomain' instead"],
        [hold(System), hold(Factor)]    = [hold(System), factor, "use 'factor' instead"],
        [hold(System), hold(unloadlib)] = [hold(System), FAIL, "see 'package'"],
        [hold(System), hold(newfuncarg)]= [hold(System), FAIL, ""],
        [hold(System), hold(newpurefunc)]= [hold(System), FAIL, ""],
        [hold(System), hold(nohistory)] = [hold(System), FAIL, ""],
        [hold(System), hold(assmem)]    = [hold(System), FAIL, ""],
        [hold(System), hold(block)]     = [hold(System), FAIL, ""],
        [hold(System), hold(bin_op)]    = [hold(System), operator, "use 'operator' instead"],
        [hold(System), hold(arrow)]     = [hold(System), FAIL, ""],
        [hold(System), hold(predecessor)]= [hold(System), FAIL, ""],
        [hold(System), hold(memory)]    = [hold(System), FAIL, ""],
        [hold(System), hold(float_gen)] = [hold(System), FAIL, ""],
        [hold(System), hold(global)]    = [hold(System), FAIL, ""],
        [hold(System), hold(topology)]  = [hold(System), FAIL, ""],
        [hold(System), hold(writequeue)]= [hold(System), FAIL, ""],
        [hold(System), hold(readqueue)] = [hold(System), FAIL, ""],
        [hold(System), hold(writepipe)] = [hold(System), FAIL, ""],
        [hold(System), hold(readpipe)]  = [hold(System), FAIL, ""],

        [hold(sharelib), hold(edit)]    = [hold(sharelib), FAIL, "it depends on the UNIX operating system"],
        [hold(sharelib), hold(errmess)] = [hold(sharelib), FAIL, "the error concept of MuPAD is currently being revised"],
        [hold(sharelib), hold(subdirs)] = [hold(sharelib), FAIL, "it depends on the UNIX operating system"],

        [hold(linalg), hold(onSystem)]  = [hold(linalg), linalg::orthog, "use linalg::orthog instead"]
):

