
// Optionen 'None', 'All', ('PreventRecursion')
prog::remember:=
  proc(FKT, DEP, OPT = hold(None), DEF = null())
    option escape, noDebug;
    local rememberTable, FN;
  begin
    if domtype(FKT) in {DOM_PROC, DOM_FUNC_ENV} then
      if domtype(FKT) = DOM_FUNC_ENV then
        subsop(FKT, 1 = prog::remember(op(FKT, 1), DEP, OPT))
      else
        rememberTable:= table();
        FN:= prog::getname(FKT);

        if OPT = hold(All) then
          subsop(proc()
                   local IND;
                   option noDebug;
                 begin
                   IND:= [[args()], [DEP(args())]];
                   if contains(rememberTable, IND) then
                     //userinfo(1, "I remember me...[".FN."]");
                     return(rememberTable[IND])
                   end_if;
                   rememberTable[IND]:= FKT(args())
                 end_proc,
                 6 = text2expr(FN),
                 1 = op(FKT, 1))
        // keine Endlosrekursion
        elif OPT = hold(PreventRecursion) then
          if DEP = FAIL then
            subsop(proc()
                   local RET;
                   option noDebug;
                   begin
//                     %if prog::traceRemember = TRUE then
                        if args(0) > 0 and args(1) = hold(Remember) then
                          //userinfo(1, "Only remember actions ... [".FN."]");
                          if args(2) = hold(ClearPrevent) then
                            for RET in rememberTable do
                              if op(RET, 2) = hold(PreventRecursion) then
                                delete rememberTable[op(RET, 1)]
                              end_if
                            end_for
                          elif args(2) = hold(Clear) then
                            rememberTable:= table()
                          elif args(2) = hold(Print) then
                            return(rememberTable)
                          end_if;
                          return()
                        end_if;
//                      end_if; //%end_if
                      if contains(rememberTable, [args()]) then
                        // fprint(0, "Recursion detected ... [".FN."]");
                        return(DEF(args()))
                      end_if;
                      rememberTable[[args()]]:= hold(PreventRecursion);
                      RET:= FKT(args());
                      delete rememberTable[[args()]];
                      RET
                    end_proc,
                    6 = text2expr(FN),
                    1 = op(FKT, 1))
          else
            subsop(proc()
                     local RET;
                     option noDebug;
                   begin
//                     %if prog::traceRemember = TRUE then
                       if args(0) > 0 and args(1) = hold(Remember) then
                         //userinfo(1, "Only remember actions ... [".FN."]");
                         if args(2) = hold(ClearPrevent) then
                           for RET in rememberTable do
                             if op(RET, 2) = hold(PreventRecursion) then
                               delete rememberTable[op(RET, 1)]
                             end_if
                           end_for
                         elif args(2) = hold(Clear) then
                           rememberTable:= table()
                         elif args(2) = hold(Print) then
                           return(rememberTable)
                         end_if;
                         return()
                       end_if;
//                     end_if; //%end_if
                     if contains(rememberTable, [args()]) then
                       RET:= rememberTable[[args()]];
                       if RET = hold(PreventRecursion) then
                         //fprint(0, "Recursion detected ... [".FN."]");
                         //delete rememberTable[[args()]];
                         return(DEF(args()))
                       elif DEP(args()) = op(op(RET, 2)) then
                         //fprint(0, "I remember me... [".FN."]");
                         return(op(op(RET, 1)))
                       end_if
                     end_if;
                     rememberTable[[args()]]:= hold(PreventRecursion);
                     RET:= FKT(args());
                     rememberTable[[args()]]:= [[RET], [DEP(args())]];
                     RET
                   end_proc,
                   6 = text2expr(FN),
                   1 = op(FKT, 1))
          end_if
        elif OPT = hold(None) then
          subsop(proc()
                   local RET;
                   option noDebug;
                 begin
                   if contains(rememberTable, [args()]) then
                     RET:= rememberTable[[args()]];
                     if DEP(args()) = op(op(RET, 2)) then
                       //userinfo(1, "I remember me... [".FN."]");
                       return(op(op(RET, 1)))
                     end_if
                   end_if;
                   RET:= FKT(args());
                   rememberTable[[args()]]:= [[RET], [DEP(args())]];
                   RET
                 end_proc,
                 6 = text2expr(FN),
                 1 = op(FKT, 1))
        else
          error("unknown option")
        end_if
      end_if
    else
      error("wrong type of argument. The first argument\n       must be a procedure or a function environment")
    end_if
  end_proc:
