// path gibt TRUE zuruck, wenn es in der Tabelle tab 
// einen Pfad von ex nach prop gibt 
property::path:=
        proc(tab, ex, prop)
          local _t;
        begin
//fprint(0, "path", ex, " -> ", prop);
          if ex = property::Null then
            return(TRUE)
          elif prop = property::Null then
            return(FALSE)
          end_if;
          if ex = prop then 
//fprint(0, "path", TRUE);
            return(TRUE);
          end_if;
          if contains(tab, ex) <> TRUE then
//fprint(0, "path", FALSE);
            return(FALSE);
          end_if;
          if tab[ex] <> {ex} then
            if contains(tab[ex], prop) then
              return(TRUE);
            else
              for _t in tab[ex] do
                if property::path(tab, _t, prop) then
                  return(TRUE);
                  break
                end_if
              end_for
            end_if
          end_if;
          return(FALSE)
        end_proc:
        
// "Uberpr"uft Teilbarkeit von Ausdrucken 
property::divis:=
        proc()
          local __i, __in;
        begin
          if contains({property::Null, Type::Zero, 0, 0.0}, args(2)) then
            return(property::Undefined)
          end_if;
          if domtype(args(1)/args(2)) = DOM_INT then
            return(TRUE)
          end_if;

          // only one indet and integer divisor - Paul
          if nops((__in:= indets(args(1)))) = 1 and
             domtype(args(2)) = DOM_INT then
            __in:= op(__in);
            for __i from 0 to args(2) - 1 do
              if subs(args(1), __in = __i) mod args(2) <> 0 then
                return(FALSE)
              end_if
            end_for;
            return(TRUE)
          end_if;

          // different indets 
          if indets(args(1)) <> indets(args(2)) then
            return(UNKNOWN)
          end_if;

          return(UNKNOWN)
        end_proc:

// Type::Constant 
property::constant:=
        proc(_x)
          local _t;
        begin
          case domtype(_x)
            of DOM_EXPR do
              if op(_x, 0) = hold(_index) then
                _t:= map([op(_x, 2..nops(_x))], property::constant);
              else
                _t:= map([op(_x)], property::constant);
              end_if;
              if contains(_t, FALSE) <> 0 then return(FALSE) end_if;
              if contains(_t, UNKNOWN) <> 0 then return(FALSE) end_if;
              return(TRUE);

            of DOM_IDENT do
              if contains(Type::ConstantIdents, _x) then return(TRUE) end_if;
              if (_t:= domtype(extop(property::_getprop(_x), 0))) = DOM_DOMAIN then
                if _t::dom::constant <> FAIL then
                  return(_t::dom::constant(_t))
                end_if
              end_if;
              return(UNKNOWN);

            of Type do
              if _x::dom::constant <> FAIL then
                return(_x::dom::constant(_x))
              end_if;
              return(FALSE);

            otherwise
              _t:= testtype(_x, Type::Constant);
            end_case;
            if _t <> TRUE then return(FALSE) end_if; _t
        end_proc:

