// $Date: 2000/11/29 14:18:11 $ $Author: bij $ $Revision: 1.14 $

// Ersetzt in dem Ausdruck ex jeden Operanden durch seinen
// Eigenschaftsausdruck
property::Ex2Px:=
	proc(_ex_ = null())
	  //option hold;
	  local __i, minprop;
	begin
	  //userinfo(2, ">Ex2Px", _ex_);
	  if domtype(_ex_) = DOM_IDENT then
	    return(property::_getprop(_ex_))
	  elif domtype(_ex_) = DOM_EXPR then
	    case type(_ex_)
              of "_plus" do
	        if type(op(_ex_)) = "_mult" and op(op(_ex_), 2) = -1 then
		  _ex_:= subsop(_ex_, 0 = _subtract, 2 = op(_ex_, [2, 1]), Unsimplified)
	        elif type(op(_ex_, 2)) = "_negate" then
		  _ex_:= subsop(_ex_, 0 = _subtract, 2 = op(_ex_, [2, 1]), Unsimplified)
		//else
		//  _ex_:= property::_getprop(_ex_)
		end_if;
		break
	      of "_mult" do
		if op(_ex_, 2) = -1 and nops(_ex_) = 2 then
		  _ex_:= subsop(_ex_, 0 = _negate, 2 = null(), Unsimplified)
		elif type(op(_ex_)) = "_power" and op(op(_ex_), 2) = -1 then
		  _ex_:= subsop(_ex_, 0 = _divide, 2 = op(_ex_, [2, 1]), Unsimplified)
	        elif type(op(_ex_, 2)) = "_invert" then
		  _ex_:= subsop(_ex_, 0 = _divide, 2 = op(_ex_, [2, 1]), Unsimplified)
                elif not iszero(op(_ex_, 2))
                     and type(op(_ex_, 2)) = DOM_RAT and op(_ex_, [2, 1]) = 1 then
		  _ex_:= subsop(_ex_, 0 = _divide, 2 = 1/op(_ex_, 2), Unsimplified)
                elif type(op(_ex_, 1)) = "_power" and type(op(_ex_, 2)) = "_power"
                     and op(_ex_, [2, 1]) = -1 and op(_ex_, [1, 2]) = op(_ex_, [2, 2]) then
                  _ex_:= subsop(_ex_, [1, 1] = hold(_negate)(op(_ex_, [1, 1])),
                                      2 = null(), Unsimplified)
                // ERROR: _invert(Intervall mit 0)
	        //elif not iszero(op(_ex_, 2)) and type(1/op(_ex_, 2)) = DOM_INT then
		//  _ex_:= subsop(_ex_, 0 = _divide, 2 = 1/op(_ex_, 2), Unsimplified)
		end_if;
		break
	      of "_power" do
		if op(_ex_, 2) = -1 then
		  _ex_:= subsop(_ex_, 0 = _invert, 2 = null(), Unsimplified)
                elif domtype(op(_ex_, 2)) = DOM_INT and op(_ex_, 2) < 0 then
                  _ex_:= hold(_invert)(subsop(_ex_, 2 = -op(_ex_, 2), Unsimplified))
		end_if;
		break
              of "RootOf" do
                return(_ex_)
            end_case;
            // impossible functions
            if contains({"int", "diff"}, type(_ex_)) then
              return(_ex_)
            end_if;
            // minimal property
            if domtype(_ex_) = DOM_EXPR
               and domtype((__i:= eval(op(_ex_, 0)))) = DOM_FUNC_ENV
               and (minprop:= __i::minprop) <> FAIL then
              if (__i:= property::Ex2Px(op(_ex_))) <> op(_ex_) then
                return(__i and minprop)
              else
                return(minprop)
              end_if
            end_if;
	    for __i from 1 to nops(_ex_) do
	      _ex_:= subsop(_ex_, __i = property::Ex2Px(op(_ex_, __i)), Unsimplified)
	    end_for
          end_if;
	  eval(_ex_)
	end_proc:
