
/*(
   test - generic property domain
          primitive implementation - only table rules
)*/

alias(test = (property::test)):

test:= newDomain("property::test"):
test::info:= "test-Domain: numeric evaluation - Properties 'test'":
test::domtype:= (()->(Type)):
test::type:= "test":
test::prop:= TRUE:
test::propdom:= hold(property::test):
test::autoload:= TRUE:
test::testtype:= Type::testtype:

test::ax:= []:

test::new:= 
	proc()
	begin
	  if args(0) > 0 then
	    new(test, args())
	  else
	    new(test, null())
	  end_if
	end_proc:

// gibt bool zuruck, ob aus arg1 -> arg2 folgt 
test::is:=
	proc()
	begin
	  bool(expr(op(args(1))) = op(args(2)))
	end_proc:

// gibt eine Regel f"ur arg1, ..., argn oder arg1, ..., argn zur"uck 
test::Is:=
	proc()
	begin
	  test()
	end_proc:

test::_and:=
	proc()
	begin
	  if args(0) = 2 then
	    if args(1) = args(2) then return(args(1)) end_if;
	    return(hold(_and)(args()))
	  else
	    return(property::Op(_and, args()))
	  end_if
	end_proc:

test::_or:=
	proc()
	begin
	end_proc:

test::_not:=
	proc()
	begin
	end_proc:

test::_plus:=
	proc()
	begin
	  property::_Op(test, _plus,
	                (()->(subsop(args(1),
			    1 = op(args(1)) + op(args(2))))),
			args())
	end_proc:

test::_subtract:=
	proc()
	begin
	  property::_Op(test, _subtract,
	                (()->(subsop(args(1),
			    1 = op(args(1)) - op(args(2))))),
			args())
	end_proc:

test::_negate:=
	proc()
	begin
	  subsop(args(), 1 = _negate(op(args(), 1)))
	end_proc:

test::_mult:=
	proc()
	begin
	  property::_Op(test, _mult,
	                (()->(subsop(args(1),
			    1 = op(args(1)) * op(args(2))))),
			args())
	end_proc:

test::_divide:=
	proc()
	begin
	  property::_Op(test, _divide,
	                (()->(subsop(args(1),
			    1 = op(args(1)) / op(args(2))))),
			args())
	end_proc:

test::_invert:=
	proc()
	begin
	  subsop(args(), 1 = _invert(op(args(), 1)))
	end_proc:

test::_power:=
	proc()
	begin
	  property::_Op(test, _power,
	                (()->(subsop(args(1),
			    1 = op(args(1)) ^ op(args(2))))),
			args())
	end_proc:

test::print:=
	proc()
	begin
	  "test(" . expr2text(op(args())) . ")"
	end_proc:

userinfo(1, "Loading 'test' done ..."):

unalias(test):


