arccos:=slot(arccos,"series",proc(f,x,n,dir)
begin
  // formula 4.4.2 of Abr. & Stegun 
  // gives too complicated results
  // series(-I*ln(f+I*sqrt(1-f^2)),x,n);

  series(PI/2-arcsin(f),x,n,
         if dir = FAIL then null() else dir end_if)
end_proc):

