
//alias(Simpl(EXPR, NEXPR) = extsubsop(EXPR, 1 = NEXPR)):

Simplify::simplify:=
  proc(X)
    local INDEX, RULES, RET;
  begin
    // index von X
    INDEX:= Simplify::index(X);
    // Regelbasis reduzieren
    RULES:= Simplify::findrule(INDEX);
    // Regel anwenden
    RET:= Simplify::_simplify(X, RULES)
    // 
    
  end_proc:

Simplify::findrule:=
  proc(INDEX)
  begin
    if INDEX = hold(All) then
      Simplify::rule
    end_if
  end_proc:

Simplify::index:=
  proc()
  begin
    hold(All)
  end_proc:

Simplify::_simplify:=
  proc(EXPR, RULES)
    local RET, k, RULE, MATCHR;
  begin
    RET:= null(); k:= 1;
    while RET = null() do
      RULE:= op(RULES, k);
      if (MATCHR:= matchlib::match(/*Simplify::expr*/(EXPR), op(RULE, 1),
                                   _if(nops(RULE) > 2, op(RULE, 2..nops(RULE)), null()))) <> FAIL then
//print("MATCHR", MATCHR, op(RULE, 2));
        RET:= subs(op(RULE, 2), op(MATCHR));
//print("RET", RET);
        EXPR:= /*Simpl(EXPR,*/ eval(RET)//)
      elif k < nops(RULES) then
        k:= k + 1
      else
        break
      end_if
    end_while;
    EXPR
  end_proc:

Simplify::expr:=
  proc(EXPR)
  begin
    extop(EXPR, 1)
  end_proc: