// $Date: 2000/05/21 15:03:15 $ $Author: bij $ $Revision: 1.3 $ 

/*--
	ln/sign -- the function attribut "sign" for ln
--*/

ln:= slot(ln,"sign",proc(x)
    local s, ss, t;
begin
    if sign(op(x,1)) = 1 then
        return( sign( op(x,1)-1 ) )
    end_if;
    s:= Re(x);
    if not has(s,{Re,Im}) and s <> x then
        ss := Im(x);
        if not has(ss,{Re,Im}) then
             t := sqrt( s^2*sign(s)^2+ss^2*sign(ss)^2 );
             if not iszero(t) then return( (s+I*ss)/t ) end_if
        end_if
    end_if;
    hold(sign)(x)
end_proc):

// end of file 
