// $Date: 2000/05/21 15:04:20 $ $Author: bij $ $Revision: 1.4 $ 

/*--
	cos/Im -- the function attribut "Im" for cos
--*/

cos := slot( cos, "Im", proc(x)
        local r, s;
    begin
        r := Re(x);
        if r = x then 
            return( 0 )
        elif not has(r,{hold(Re),hold(Im)}) then
            s := Im(x);
            if not has(s,{hold(Re),hold(Im)}) then
                return( -sin(r)*sinh(s) )
            end_if
        end_if;
        return( FAIL )
    end_proc
):

// end of file 
