// $Date: 2000/05/21 15:04:31 $ $Author: bij $ $Revision: 1.5 $ 

/*--
	abs/rectform -- the function attribut "rectform" for abs
--*/

abs := slot( abs, "rectform", proc(xx)
        local a, b, x;
    begin
        x := rectform::new(xx);

        if extop(x,3) <> 0 then
            new( rectform,0,0,hold(abs)(rectform::expr(x)) )
        else
            a := extop(x,1);
            b := extop(x,2);
            if domtype(a+I*b) = DOM_COMPLEX
               and (domtype(a) = DOM_FLOAT or domtype(b) = DOM_FLOAT)
            then rectform::new(abs(a+I*b))
            elif sign(a+I*b) = 0 or sign(a+I*b) = 1 then
                new(rectform,a+I*b,0,0)
            elif iszero(a) or iszero(b) then
                new(rectform,abs(a+I*b),0,0)
            else
                new(rectform,sqrt(a^2+b^2),0,0)
            end_if
        end_if
    end_proc
):

// end of file 
