/*--
	_mult/simplify -- the function attribut "simplify" for _mult
--*/

_mult:=slot(_mult,"simplify",proc(e)
    name _mult::simplify;
    local t, l;
begin
    l:= rationalize( e );
    if l[2]={} then 
	// try normal 
	return( normal(l[1]) )
    elif type(l[1]) <> "_mult" then
	// try normal 
	return( normal(e) )
    else
	//t:= split( l[1],_not@has,map(l[2],op,1) )
	t:= split(l[1], X->bool(not has(X,map(l[2],op,1)) and not testtype(X,Type::Numeric)));
    end_if;
    if t[1] = 1 then
	e:= split(e,X -> bool(hastype(X,"_power") and not testtype(X,Type::Constant)));
	t:= e[1];
	if type(t) = "_mult" then
	    t:= map(t,simplify);
	    t:= combine(t)
	else // examine exponent 
	    if type(t) = "_power" and type(op(t,2)) = "_plus" then // a^(b+c) 
	    // try to expand 
		t:= expand(t)
	    else
		t:= simplify(t)
	    end_if
	end_if;
        e := _mult(e[2], e[3]);
        if type(e) = "_mult" then
          _mult(t, combine(map(e, simplify)))
        else
          _mult(t, combine(simplify(e)))
        end_if;
    else _mult( normal(t[1]), simplify(subs(t[2],l[2])), simplify(subs(t[3],l[2])) )
    end_if
end_proc):

// end of file 
