anames :=
  proc(DOM, userDefined = null()) : DOM_SET 
    local res;
  begin
    if testargs() then
      if args(0) > 2 or args(0) = 0 then
        error("wrong number of arguments")
      end_if;
      if (DOM_DOMAIN <> domtype(DOM) and DOM <> hold(Properties) and 
          DOM <> hold(All) ) or
         (args(0) = 2 and userDefined <> hold(User)) then
        error("illegal argument");
      end_if;
    end_if;
    if domtype(DOM) = DOM_DOMAIN then
       res := select(stdlib::anames(3), 
                     x->domtype(context(hold(val)(x)))=DOM);
    else
       if DOM = hold(Properties) then 
         res := stdlib::anames(4)	
       elif DOM = hold(All) then 
         res := stdlib::anames(3)	
       end_if;
    end_if;
    
    if userDefined = hold(User) then
      res := res minus stdlib::PROTECTED 
                 minus stdlib::ENVIRONMENT_VARIABLES 
                 minus stdlib::SYSTEM_CONSTANTS;
    end_if;
    res
  end_proc:
