// $Date: 2000/05/21 15:03:50 $ $Author: bij $ $Revision: 1.5 $ 

// kg, 13/01/95 

/*++
unalias -- un-define alias name

unalias([expr,...])

expr - alias name to un-define

unalias(e1,...,en) un-defines the alias names ei.
unalias() un-defines all alias names.
++*/

unalias:= proc()
    option hold, noDebug;
    local i, at;
begin
    at:= _parser_config();
    if at = null() then return(null()) end_if;
    
    if args(0) = 0 then
        // remove all aliases 
	_parser_config( [table(), table(), table(), at[4]] );
    	return(null())
    end_if;

    // remove from alias tables 
    for i from 1 to args(0) do
	if contains(at[2], args(i)) then
	    delete at[1][at[2][args(i)]];
	    delete at[2][args(i)]
	else
	    delete at[3][args(i)]
	end_if
    end_for;
    _parser_config(at);
    null()
end_proc:

// end of file 
