/* $Date: 2000/07/05 07:37:42 $  $Author: kg $  $Revision: 1.6 $ */
/*
 * Filename:     MGR_defaults.h
 *
 * Inhalt:       Enth"alt die Definition der Funktionen, zum Behandeln der
 *               Defaults, die sowohl in Kern als auch in VCam
 *               benutzt werden.
 *
 * Autor:        Gudrun Oevel
 *
 * Datum:        31.08.1993
 */

#ifndef __MGR_defaults__
#define __MGR_defaults__

#include "MCT_iostream.h"


/*
 * Konstanten
 */

#define  MGRC_VCAM_DEFAULTS_HEADER           "VCam-Default-Values"
#define  MGRC_VCAM_DEFAULTS_HEADER_LENGTH    19

/*
 * Funktionen
 */


#ifndef MSDOS
void       MGR_read_default_file
                     (   MCLT_iostream    fp,
                         MGRT_Defaults    *defaults
                     );
#endif // ! MSDOS

void        MGR_get_default_scene(
                       long             dimension,
                       MGRT_Scene       *scene,
                       MGRT_Defaults    *defaults
                      );

void        MGR_get_default_object(
                       long             dimension,
		       long		mode,
                       long             number,
                       MGRT_Object      *actobj,
                       MGRT_Defaults    *actdef
                      );

void MGR_init_defaults(MGRT_Defaults *def);

#endif /* __MGR_defaults__ */
